Package: AUCell
Type: Package
Title: AUCell: Analysis of 'gene set' activity in single-cell RNA-seq
        data (e.g. identify cells with specific gene signatures)
Version: 1.34.0
Date: 2024-03-09
Author: Sara Aibar, Stein Aerts. Laboratory of Computational Biology.
    VIB-KU Leuven Center for Brain & Disease Research. Leuven, Belgium.
Maintainer: Gert Hulselmans <Gert.Hulselmans@kuleuven.be>
Description: AUCell allows to identify cells with active gene sets
    (e.g. signatures, gene modules...) in single-cell RNA-seq data.
    AUCell uses the "Area Under the Curve" (AUC) to calculate whether a critical
    subset of the input gene set is enriched within the expressed genes for each cell.
    The distribution of AUC scores across all the cells allows exploring the
    relative expression of the signature. Since the scoring method is ranking-based,
    AUCell is independent of the gene expression units and the normalization procedure.
    In addition, since the cells are evaluated individually, it can easily be
    applied to bigger datasets, subsetting the expression matrix if needed.
URL: http://scenic.aertslab.org
Imports: DelayedArray, DelayedMatrixStats, data.table, graphics,
        grDevices, GSEABase, Matrix, methods, mixtools, R.utils, stats,
        SummarizedExperiment, BiocGenerics, utils
Enhances: doMC, doRNG, doParallel, foreach
Suggests: Biobase, BiocStyle, doSNOW, dynamicTreeCut, DT, GEOquery,
        knitr, NMF, plyr, R2HTML, rmarkdown, reshape2, plotly, Rtsne,
        testthat, zoo
License: GPL-3
biocViews: SingleCell, GeneSetEnrichment, Transcriptomics,
        Transcription, GeneExpression, WorkflowStep, Normalization
VignetteBuilder: knitr
RoxygenNote: 7.2.0
git_url: https://git.bioconductor.org/packages/AUCell
git_branch: RELEASE_3_23
git_last_commit: 825bca6
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-29 20:26:37 UTC; biocbuild

# AUCell
AUCell is an R-package to analyze the state of gene-sets in single-cell RNA-seq data (i.e. identify cells with active gene signatures).

*Availability*: 

- The newest stable version of AUCell is available in *[Bioconductor](https://bioconductor.org/packages/AUCell)*. 
The package also contains a **tutorial** [(vignette)](https://bioconductor.org/packages/release/bioc/vignettes/AUCell/inst/doc/AUCell.html) with information on how to run AUCell and how to interprete its results.

- This Github repository is meant mostly for development. "Use at your own risk" :-). Developers are welcome to contribute. 

#' @importFrom DelayedArray DelayedArray blockApply colAutoGrid
#' @title Run AUCell 
#' @description Runs AUCell (calculates the ranking + score genesets)
#' @param exprMat Expression matrix (genes/regions as rows, cells as columns)
#' The expression matrix can also be provided as one of the R/Bioconductor classes:
#' \itemize{
#' \item \link[Matrix]{dgCMatrix-class}:
#' Sparse matrix 
#' \item \link{RangedSummarizedExperiment} and derived classes (e.g. \link[SingleCellExperiment]{SingleCellExperiment} ):
#' The matrix will be obtained through assay(exprMatrix),
#' -which will extract the first assay (usually the counts)-
#' or the assay name given in 'assayName'
#' }
#' @param geneSets List of gene-sets (or signatures) to test in the cells.
#' The gene-sets should be provided as \code{\link{GeneSet}},
#' \code{\link{GeneSetCollection}} or character list (see examples).
#' @param featureType Name for the rows (e.g. "genes"). Only for naming the rankings, not used internally.
#' @param keepZeroesAsNA Convert zeroes to NA instead of locating randomly at the end of the ranking.
#' @param normAUC Whether to normalize the maximum possible AUC to 1 (Default: TRUE).
#' @param aucMaxRank Threshold to calculate the AUC (see 'details' section)
#' @param BPPARAM Set to use multiple cores. Only used if 'splitByBlocks=TRUE'
#' @param assayName Name of the assay containing the expression matrix (e.g. in \link[SingleCellExperiment]{SingleCellExperiment} objects)
#' @param ... Other arguments
#' @return Matrix with the AUC values (gene-sets as rows, cells as columns).
#' @details In a simplified way, the AUC value represents the fraction of genes,
#'  within the top X genes in the ranking, that are included in the signature.
#' The parameter 'aucMaxRank' allows to modify the number of genes
#' (maximum ranking) that is used to perform this computation.
#' By default, it is set to 5\% of the total number of genes in the rankings.
#' Common values may range from 1 to 20\%.
#' @seealso Includes \code{\link{AUCell_buildRankings}} and \code{\link{AUCell_calcAUC}}.
#' Next step in the workflow: \code{\link{AUCell_exploreThresholds}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("AUCell")}
#' @example inst/examples/example_AUCell_run.R
#'
#' @rdname AUCell_run
#' @export
setGeneric("AUCell_run", signature="exprMat",
           function(exprMat, 
                    geneSets, 
                    featureType='genes',
                    keepZeroesAsNA=FALSE, 
                    normAUC=TRUE, 
                    aucMaxRank=ceiling(0.05*nrow(exprMat)), 
                    BPPARAM=NULL,
                    ...)
           {
             standardGeneric("AUCell_run")
           })

# Sparse matrix
#' @rdname AUCell_run
#' @aliases AUCell_run,dgCMatrix-method
setMethod("AUCell_run", "dgCMatrix", 
          function(exprMat, 
                   geneSets, 
                   featureType='genes',
                   keepZeroesAsNA=FALSE, 
                   normAUC=TRUE, 
                   aucMaxRank=ceiling(0.05*nrow(exprMat)), 
                   BPPARAM=NULL)
          {
                        .AUCell_run(exprMat=exprMat, geneSets=geneSets, featureType=featureType, 
                                    keepZeroesAsNA=keepZeroesAsNA, 
                                    normAUC=normAUC, aucMaxRank=aucMaxRank, 
                                    BPPARAM=BPPARAM)
          })

# Non-sparse matrix
#' @rdname AUCell_run
#' @aliases AUCell_run,matrix-method
setMethod("AUCell_run", "matrix",
          function(exprMat, 
                   geneSets, 
                   featureType="genes", 
                   keepZeroesAsNA=FALSE, 
                   normAUC=TRUE, 
                   aucMaxRank=ceiling(0.05*nrow(exprMat)), 
                   BPPARAM=NULL)
          {
            .AUCell_run(exprMat=exprMat, geneSets=geneSets, featureType=featureType, 
                        keepZeroesAsNA=keepZeroesAsNA, 
                        normAUC=normAUC, aucMaxRank=aucMaxRank, 
                        BPPARAM=BPPARAM)
          })

#' @rdname AUCell_run
#' @aliases AUCell_run,SummarizedExperiment-method
setMethod("AUCell_run", "SummarizedExperiment",
          function(exprMat, 
                   geneSets, 
                   featureType="genes", 
                   keepZeroesAsNA=FALSE, 
                   normAUC=TRUE, 
                   aucMaxRank=ceiling(0.05*nrow(exprMat)), 
                   BPPARAM=NULL, assayName=NULL)
          {
            if(is.null(assayName))
            {
              if(length(SummarizedExperiment::assays(exprMat))>1)
                warning("More than 1 assays are available. Using the first one (", 
                        names(assays(exprMat))[1], ").")
              
              exprMat <- SummarizedExperiment::assay(exprMat)
            }else{
              if(!assayName %in% names(assays(exprMat)))
                stop("There isn't an assay named ", assayName, ".")
              
              exprMat <- SummarizedExperiment::assays(exprMat)[[assayName]]
            }
            
            .AUCell_run(exprMat=exprMat, geneSets=geneSets, featureType=featureType, 
                        keepZeroesAsNA=keepZeroesAsNA, 
                        normAUC=normAUC, aucMaxRank=aucMaxRank, 
                        BPPARAM=BPPARAM)
          })

.AUCell_run <- function(exprMat, 
                      geneSets, 
                      featureType="genes", 
                      keepZeroesAsNA=FALSE, 
                      normAUC=TRUE, 
                      aucMaxRank=ceiling(0.05*nrow(exprMat)), 
                      BPPARAM=NULL) 
{
  collected <- blockApply(DelayedArray(exprMat), 
                          FUN=.AUCell_run_internal, 
                          geneSets=geneSets,
                          featureType=featureType,
                          keepZeroesAsNA=keepZeroesAsNA,
                          normAUC=normAUC,
                          aucMaxRank=aucMaxRank,
                          BPPARAM=BPPARAM,
                          grid=colAutoGrid(exprMat)
  )
  do.call(cbind, collected)
}

.AUCell_run_internal <- function(exprMat_block, geneSets, featureType, keepZeroesAsNA, normAUC, aucMaxRank) 
{
  ranked <- AUCell_buildRankings(exprMat_block, splitByBlocks=FALSE, 
                                 featureType=featureType,
                                 keepZeroesAsNA=keepZeroesAsNA, 
                                 plotStats=FALSE, verbose=FALSE)
  AUCell_calcAUC(geneSets, ranked, normAUC=normAUC, aucMaxRank=aucMaxRank, verbose=FALSE)
}

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)
#' @rawNamespace import(data.table, except = shift)
#' @import GSEABase
#' @importFrom stats setNames
#' @importFrom methods new
#' @title Calculate AUC
#' @description Calculates the 'AUC' for each gene-set in each cell.
#' @param geneSets List of gene-sets (or signatures) to test in the cells.
#' The gene-sets should be provided as \code{\link{GeneSet}},
#' \code{\link{GeneSetCollection}} or character list (see examples).
#' @param rankings 'Rankings' created for this dataset with
#' \code{\link{AUCell_buildRankings}}.
#' @param nCores Number of cores to use for computation.
#' @param normAUC Wether to normalize the maximum possible AUC to 1 (Default: TRUE).
#' @param aucMaxRank Threshold to calculate the AUC (see 'details' section)
#' @param verbose Should the function show progress messages? (TRUE / FALSE)
#' @return Matrix with the AUC values (gene-sets as rows, cells as columns).
#' @details In a simplified way, the AUC value represents the fraction of genes,
#'  within the top X genes in the ranking, that are included in the signature.
#' The parameter 'aucMaxRank' allows to modify the number of genes
#' (maximum ranking) that is used to perform this computation.
#' By default, it is set to 5\% of the total number of genes in the rankings.
#' Common values may range from 1 to 20\%.
#' @seealso Previous step in the workflow: \code{\link{AUCell_buildRankings}}.
#' Next step in the workflow: \code{\link{AUCell_exploreThresholds}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("AUCell")}
#' @example inst/examples/example_AUCell_calcAUC.R
#'
# @docType methods
#' @rdname AUCell_calcAUC
#' @export
setGeneric("AUCell_calcAUC", signature="geneSets",
  function(geneSets, rankings, nCores=1, normAUC=TRUE,
          aucMaxRank=ceiling(0.05*nrow(rankings)), verbose=TRUE)
  {
   standardGeneric("AUCell_calcAUC")
})

#' @rdname AUCell_calcAUC
#' @aliases AUCell_calcAUC,list-method
setMethod("AUCell_calcAUC", "list",
  function(geneSets, rankings, nCores=1, normAUC=TRUE,
           aucMaxRank=ceiling(0.05*nrow(rankings)), verbose=TRUE)
  {
    .AUCell_calcAUC(geneSets=geneSets, rankings=rankings, nCores=nCores,
                    aucMaxRank=aucMaxRank, verbose=verbose)
  })

#' @rdname AUCell_calcAUC
#' @aliases AUCell_calcAUC,character-method
setMethod("AUCell_calcAUC", "character",
  function(geneSets, rankings, nCores=1, normAUC=TRUE,
           aucMaxRank=ceiling(0.05*nrow(rankings)), verbose=TRUE)
  {
    geneSets <- list(geneSet=geneSets)

    .AUCell_calcAUC(geneSets=geneSets, rankings=rankings, nCores=nCores,
                    aucMaxRank=aucMaxRank, verbose=verbose)
  })

#' @rdname AUCell_calcAUC
#' @aliases AUCell_calcAUC,GeneSet-method
setMethod("AUCell_calcAUC", "GeneSet",
  function(geneSets, rankings, nCores=1, normAUC=TRUE,
           aucMaxRank=ceiling(0.05*nrow(rankings)), verbose=TRUE)
  {
    geneSets <- setNames(list(GSEABase::geneIds(geneSets)),
                         GSEABase::setName(geneSets))

    .AUCell_calcAUC(geneSets=geneSets, rankings=rankings, nCores=nCores,
                    aucMaxRank=aucMaxRank, verbose=verbose)
  })

#' @rdname AUCell_calcAUC
#' @aliases AUCell_calcAUC,GeneSetCollection-method
setMethod("AUCell_calcAUC", "GeneSetCollection",
  function(geneSets, rankings, nCores=1, normAUC=TRUE,
           aucMaxRank=ceiling(0.05*nrow(rankings)), verbose=TRUE)
  {
    geneSets <- GSEABase::geneIds(geneSets)

    .AUCell_calcAUC(geneSets=geneSets, rankings=rankings, nCores=nCores,
                    aucMaxRank=aucMaxRank, verbose=verbose)
  })

# Takes named character list as input
.AUCell_calcAUC <- function(geneSets, rankings, 
                            nCores=1, mctype=c("domc","snow")[1],
                            normAUC=TRUE,
                            aucMaxRank=ceiling(0.05*nrow(rankings)), verbose=TRUE)
{
  if(!is.list(geneSets))
    stop("geneSets should be a named list.")
  if(is.null(names(geneSets)))
    stop("geneSets should be a named list.")
  if(any(lengths(geneSets)<=0))
  {
    warning("Ignoring the following empty sets: ", paste0(names(lengths(geneSets))[which(lengths(geneSets)<=0)], collapse=", "))
    geneSets <- geneSets[which(lengths(geneSets)>0)]
  }
  if(length(geneSets)<=0) stop("No geneSets provided or remaining.")
  
  if(nCores > length(geneSets))
    nCores <- length(geneSets) # No point in using more...
  if((aucMaxRank < 300) && verbose)
    warning("Using only the first ", aucMaxRank,
            " genes (aucMaxRank) to calculate the AUC.", immediate.=TRUE)
  if(aucMaxRank <=0) stop("aucMaxRank should be a positive value.")

  if(!methods::is(rankings,"aucellResults") ||
     SummarizedExperiment::assayNames(rankings)!="ranking"){
    if(methods::is(rankings,"matrixWrapper"))
    {
      stop('These rankings were built with a previous AUCell version. \n",
           "Please update them with updateAucellResults(..., objectType="ranking")')
    }
    stop("Rankings should be a the object returned by AUCell_buildRankings()")
  } else{
    rankings <- getRanking(rankings)
  }
  # if(!key(rankings) == "rn") stop("The rankings key should be 'rn'.")

  if(!normAUC) .AUC.geneSet <- .AUC.geneSet_old()
  if(normAUC) .AUC.geneSet <- .AUC.geneSet_norm
  
  ######################################################################
  #### 1. Calculate the AUC for each gene set
  if(nCores==1)
  {
    gSetName <- NULL
    aucMatrix <- sapply(names(geneSets), function(gSetName)
      .AUC.geneSet(geneSet=geneSets[[gSetName]], rankings=rankings,
                   aucMaxRank=aucMaxRank, gSetName=gSetName))
    aucMatrix <- t(aucMatrix)
  }
  if(nCores>1)
  {
    if(!mctype %in% c("domc")) stop("Valid 'mctype': 'doMC'") # 'snow'  
    if(mctype=="snow")
    {
      # library(parallel)
      # library(doSNOW)
      # library(plyr)
      cl <- parallel::makeCluster(nCores, type = "SOCK")
      doSNOW::registerDoSNOW(cl)
      if(verbose) message("Using ", length(cl), " cores with SNOW.")
      # clusterEvalQ(cl, library(AUCell))
      parallel::clusterExport(cl, c("geneSets", "rankings", "aucMaxRank", ".AUC.geneSet", ".auc", ".AUC.geneSet_norm", ".AUC.geneSet_old"), envir=environment())
      opts <- list(preschedule=TRUE)
      # clusterSetRNGStream(cl, seed)
      aucMatrix <- suppressWarnings(plyr::llply(.data=names(geneSets), 
                               .fun=function(gSetName) 
                                 setNames(list(.AUC.geneSet(geneSet=geneSets[[gSetName]], rankings=rankings, aucMaxRank=aucMaxRank, gSetName=gSetName)), gSetName),
                               .parallel=TRUE, .paropts=list(.options.snow=opts), .inform=FALSE))
      aucMatrix <- do.call(rbind,
                           unlist(aucMatrix, recursive=FALSE))
      parallel::stopCluster(cl)
    }
    if(mctype=="domc")
    {
     doMC::registerDoMC(nCores)
     if(verbose)
       message("Using ", foreach::getDoParWorkers(), " cores with doMC.")
  
     aucMatrix <- foreach::"%dopar%"(foreach::foreach(gSetName=names(geneSets)),
      {
        setNames(list(.AUC.geneSet(geneSet=geneSets[[gSetName]],
                                   rankings=rankings, aucMaxRank=aucMaxRank,
                                   gSetName=gSetName)),
                 gSetName)
      })
      aucMatrix <- do.call(rbind,
                           unlist(aucMatrix, recursive=FALSE))
    }
  }

  aucMatrix <- aucMatrix[intersect(names(geneSets), rownames(aucMatrix)),,drop=FALSE]
  missingSets <- names(geneSets)[which(!names(geneSets) %in% rownames(aucMatrix))]
  if(length(missingSets)>0) warning("The AUC for the following sets was not calculated: ", paste(missingSets, collapse=", "))
  
  ######################################################################
  ##### Messages for missing genes
  missingGenes <- as.matrix(aucMatrix[,c("missing", "nGenes") , drop=FALSE])
  missingPercent <- as.numeric(missingGenes[,"missing"])/
    as.numeric(missingGenes[,"nGenes"])
  missingPercent <- setNames(missingPercent, rownames(missingGenes))

  if(all(missingPercent>=.80))
    stop("Fewer than 20% of the genes in the gene sets are included in the rankings.",
         "Check wether the gene IDs in the 'rankings' and 'geneSets' match.")

  if(any(missingPercent>.80))
  {
    warning("The following gene sets will be excluded from the analysis",
            "(less than 20% of their genes are available):\n",
            paste(names(missingPercent)[which(missingPercent >= .80)],
                  collapse=", "),
            sep="", immediate.=TRUE)
    aucMatrix <- aucMatrix[which(missingPercent < .80),,drop=FALSE]
  }

  missingGenes <- missingGenes[rownames(aucMatrix),,drop=FALSE]
  if(sum(missingGenes[,"missing"])>0)
  {
    msg1 <- "Genes in the gene sets NOT available in the dataset: \n"
    msg2 <-  sapply(rownames(missingGenes)[which(missingGenes[,"missing"]>0.01)],
                    function(gSetName){
                      paste("\t", gSetName, ": \t",
                            missingGenes[gSetName,"missing"],
                            " (",round(missingPercent[gSetName]*100),"% of ",
                            missingGenes[gSetName,"nGenes"],")",sep="")
                    })
    if(verbose)
      message(msg1, paste(msg2, collapse="\n"), sep="")
  }
  # (remove missing genes info from AUC matrix)
  aucMatrix <- aucMatrix[,1:(ncol(aucMatrix)-2), drop=FALSE]

  ######################################################################
  #### End: Return
  names(dimnames(aucMatrix)) <- c("gene sets", "cells")
  new("aucellResults",
      SummarizedExperiment::SummarizedExperiment(assays=list(AUC=aucMatrix)))
}

# add?: AUCThreshold
.AUC.geneSet_old <- function(geneSet, rankings, aucMaxRank, gSetName="")
{
  geneSet <- unique(geneSet)
  nGenes <- length(geneSet)
  geneSet <- geneSet[which(geneSet %in% rownames(rankings))]
  missing <- nGenes-length(geneSet)

  gSetRanks <- rankings[which(rownames(rankings) %in% geneSet),,drop=FALSE]
  rm(rankings)

  aucThreshold <- round(aucMaxRank)
  maxAUC <- aucThreshold * nrow(gSetRanks)  # database.gene_count 

  # Apply by columns (i.e. to each ranking)
  auc <- apply(gSetRanks, 2, .auc, aucThreshold, maxAUC)

  return(c(auc, missing=missing, nGenes=nGenes))
}

.AUC.geneSet_norm <- function(geneSet, rankings, aucMaxRank, gSetName="")
{
  geneSet <- unique(geneSet)
  nGenes <- length(geneSet)
  geneSet <- geneSet[which(geneSet %in% rownames(rankings))]
  missing <- nGenes-length(geneSet)
  
  gSetRanks <- rankings[which(rownames(rankings) %in% geneSet),,drop=FALSE]
  rm(rankings)
  
  aucThreshold <- round(aucMaxRank)
  ########### NEW version:  #######################
  x_th <- 1:nrow(gSetRanks)
  x_th <- sort(x_th[x_th<aucThreshold])
  y_th <- seq_along(x_th)
  maxAUC <- sum(diff(c(x_th, aucThreshold)) * y_th) 
  ############################################
  
  # Apply by columns (i.e. to each ranking)
  auc <- apply(gSetRanks, 2, .auc, aucThreshold, maxAUC)
  
  return(c(auc, missing=missing, nGenes=nGenes))
}


# oneRanking <- gSetRanks[,3, with=FALSE]
.auc <- function(oneRanking, aucThreshold, maxAUC)
{
  x <- unlist(oneRanking)

  x <- sort(x[x<aucThreshold])
  y <- seq_along(x)
  sum(diff(c(x, aucThreshold)) * y)/maxAUC
}

## ----echo=FALSE, message=FALSE, warning=FALSE---------------------------------
suppressPackageStartupMessages({
library(AUCell)
#library(Biobase)
library(GSEABase)
library(data.table)
library(DT)
library(NMF)
library(plotly)
library(GEOquery)
library(Matrix)
# library(doMC);library(doRNG) # Loaded by AUCell, to avoid messages. Not available in windows?
})

# To build a personalized report, update this working directory:
dir.create("AUCell_tutorial")
knitr::opts_knit$set(root.dir = 'AUCell_tutorial')

## ----Overview, eval=FALSE-----------------------------------------------------
# library(AUCell)
# geneSets <- list(geneSet1=c("gene1", "gene2", "gene3"))
# 
# # Calculate enrichment scores
# cells_AUC <- AUCell_run(exprMatrix, geneSets, aucMaxRank=nrow(cells_rankings)*0.05)
# 
# # Optional: Set the assignment thresholds
# par(mfrow=c(3,3))
# set.seed(123)
# cells_assignment <- AUCell_exploreThresholds(cells_AUC, plotHist=TRUE, nCores=1, assign=TRUE)

## ----citation, echo=FALSE-----------------------------------------------------
print(citation("AUCell")[1], style="textVersion")

## ----setup, eval=FALSE--------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# # To support paralell execution:
# BiocManager::install(c("doMC", "doRNG","doSNOW"))
# # For the main example:
# BiocManager::install(c("mixtools", "SummarizedExperiment"))
# # For the examples in the follow-up section of the tutorial:
# BiocManager::install(c("DT", "plotly", "NMF", "d3heatmap",
#                        "dynamicTreeCut", "R2HTML", "Rtsne", "zoo"))

## ----vignette, eval=FALSE-----------------------------------------------------
# # Explore tutorials in the web browser:
# browseVignettes(package="AUCell")
# 
# # Commnad line-based:
# vignette(package="AUCell") # list
# vignette("AUCell") # open

## ----editRmd, eval=FALSE------------------------------------------------------
# vignetteFile <- paste(file.path(system.file('doc', package='AUCell')), "AUCell.Rmd", sep="/")
# # Copy to edit as markdown
# file.copy(vignetteFile, ".")
# # Alternative: extract R code
# Stangle(vignetteFile)

## ----setwd, eval=FALSE--------------------------------------------------------
# dir.create("AUCell_tutorial")
# setwd("AUCell_tutorial") # or in the first code chunk (kntr options), if running as Notebook

## ----loadingExprMat, eval=FALSE-----------------------------------------------
# # i.e. Reading from a text file
# exprMatrix <- read.table("myCountsMatrix.tsv")
# 
# # or single-cell experiment
# exprMatrix <- assay(mySingleCellExperiment)
# 
# ### Convert to sparse:
# exprMatrix <- as(exprMatrix, "dgCMatrix")

## ----GEOdataset, cache=TRUE, results='hide', message=FALSE, eval=TRUE---------
# (Downloads the data)
if (!requireNamespace("GEOquery", quietly = TRUE)) BiocManager::install("GEOquery")
library(GEOquery)
# gse <- getGEO('GSE60361') # does not work, the matrix is in a suppl file
geoFile <- "GSE60361_C1-3005-Expression.txt.gz"
download.file("https://ftp.ncbi.nlm.nih.gov/geo/series/GSE60nnn/GSE60361/suppl/GSE60361_C1-3005-Expression.txt.gz", destfile = geoFile)

library(data.table)
exprMatrix <- fread(geoFile, sep="\t")
geneNames <- unname(unlist(exprMatrix[,1, with=FALSE]))
exprMatrix <- as.matrix(exprMatrix[,-1, with=FALSE])
rownames(exprMatrix) <- geneNames
exprMatrix <- exprMatrix[unique(rownames(exprMatrix)),]
dim(exprMatrix)
exprMatrix[1:5,1:4]

# Remove file(s) downloaded:
file.remove(geoFile)

# Convert to sparse
library(Matrix)
exprMatrix <- as(exprMatrix, "dgCMatrix")

# Save for future use
mouseBrainExprMatrix <- exprMatrix
save(mouseBrainExprMatrix, file="exprMatrix_MouseBrain.RData")

## ----randomSamples------------------------------------------------------------
# load("exprMatrix_MouseBrain.RData")
set.seed(333)
exprMatrix <- mouseBrainExprMatrix[sample(rownames(mouseBrainExprMatrix), 5000),]

## ----dimExprMat---------------------------------------------------------------
dim(exprMatrix)

## ----geneSetsFake-------------------------------------------------------------
library(GSEABase)
genes <- c("gene1", "gene2", "gene3")
geneSets <- GeneSet(genes, setName="geneSet1")
geneSets

## ----geneSets-----------------------------------------------------------------
library(AUCell)
library(GSEABase)
gmtFile <- paste(file.path(system.file('examples', package='AUCell')), "geneSignatures.gmt", sep="/")
geneSets <- getGmt(gmtFile)

## ----geneSetsNgenes-----------------------------------------------------------
geneSets <- subsetGeneSets(geneSets, rownames(exprMatrix)) 
cbind(nGenes(geneSets))

## ----geneSetsRename-----------------------------------------------------------
geneSets <- setGeneSetNames(geneSets, newNames=paste(names(geneSets), " (", nGenes(geneSets) ,"g)", sep=""))

## ----hkGs---------------------------------------------------------------------
# Random
set.seed(321)
extraGeneSets <- c(
  GeneSet(sample(rownames(exprMatrix), 50), setName="Random (50g)"),
  GeneSet(sample(rownames(exprMatrix), 500), setName="Random (500g)"))

countsPerGene <- apply(exprMatrix, 1, function(x) sum(x>0))
# Housekeeping-like
extraGeneSets <- c(extraGeneSets,
                   GeneSet(sample(names(countsPerGene)[which(countsPerGene>quantile(countsPerGene, probs=.95))], 100), setName="HK-like (100g)"))

geneSets <- GeneSetCollection(c(geneSets,extraGeneSets))
names(geneSets)

## ----runAUCell, cache=TRUE----------------------------------------------------
cells_AUC <- AUCell_run(exprMatrix, geneSets)
save(cells_AUC, file="cells_AUC.RData")

## -----------------------------------------------------------------------------
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=FALSE)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings)

## ----buildRankings, cache=TRUE, fig.width=5, fig.height=5---------------------
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=TRUE)

## -----------------------------------------------------------------------------
cells_rankings

## ----saveRankings, eval=FALSE-------------------------------------------------
# save(cells_rankings, file="cells_rankings.RData")

## ----explainAUC, echo=FALSE---------------------------------------------------
geneSet <- geneSets[[1]]
gSetRanks <- cells_rankings[geneIds(geneSet),]

par(mfrow=c(1,2))
set.seed(222)
aucMaxRank <- nrow(cells_rankings)*0.05
na <- sapply(c(1, 2000), function(i){
  x <- sort(getRanking(gSetRanks[,i]))
  aucCurve <- cbind(c(0, x, nrow(cells_rankings)), c(0:length(x), length(x)))
  op <- par(mar=c(5, 6, 4, 2) + 0.1)
  plot(aucCurve, 
       type="s", col="darkblue", lwd=1, 
       xlab="Gene rank", ylab=paste("# genes in the gene set \n Gene set:", setName(geneSet)), 
       xlim=c(0, aucMaxRank*2), ylim=c(0, nGenes(geneSet)*.20), 
       main="Recovery curve", 
       sub=paste("Cell:", colnames(gSetRanks)[i]))
  aucShade <- aucCurve[which(aucCurve[,1] < aucMaxRank),]
  aucShade <- rbind(aucShade, c(aucMaxRank, nrow(aucShade)))
  aucShade[,1] <-  aucShade[,1]-1
  aucShade <- rbind(aucShade, c(max(aucShade),0))
  polygon(aucShade, col="#0066aa40", border=FALSE)
  
  abline(v=aucMaxRank, lty=2)
  text(aucMaxRank-50, 5, "AUC")
})

## ----calcAUC, cache=TRUE, warning=FALSE---------------------------------------
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings)
save(cells_AUC, file="cells_AUC.RData")

## ----exploreThresholds, warning=FALSE, fig.width=7, fig.height=7--------------
set.seed(333)
par(mfrow=c(3,3)) 
cells_assignment <- AUCell_exploreThresholds(cells_AUC, plotHist=TRUE, assign=TRUE) 
warningMsg <- sapply(cells_assignment, function(x) x$aucThr$comment)
warningMsg[which(warningMsg!="")]

## ----explThr1-----------------------------------------------------------------
cells_assignment$Oligodendrocyte_Cahoy$aucThr$thresholds

## ----explThr2-----------------------------------------------------------------
cells_assignment$Oligodendrocyte_Cahoy$aucThr$selected
# getThresholdSelected(cells_assignment)

## ----cellsAssigned------------------------------------------------------------
oligodencrocytesAssigned <- cells_assignment$Oligodendrocyte_Cahoy$assignment
length(oligodencrocytesAssigned)
head(oligodencrocytesAssigned)

## ----AUCell_plot--------------------------------------------------------------
geneSetName <- rownames(cells_AUC)[grep("Oligodendrocyte_Cahoy", rownames(cells_AUC))]
AUCell_plotHist(cells_AUC[geneSetName,], aucThr=0.25)
abline(v=0.25)

## ----explThr3-----------------------------------------------------------------
newSelectedCells <- names(which(getAUC(cells_AUC)[geneSetName,]>0.08))
length(newSelectedCells)
head(newSelectedCells)

## ----explAssignment-----------------------------------------------------------
cellsAssigned <- lapply(cells_assignment, function(x) x$assignment)
assignmentTable <- reshape2::melt(cellsAssigned, value.name="cell")
colnames(assignmentTable)[2] <- "geneSet"
head(assignmentTable)

## ----assignmentMat------------------------------------------------------------
assignmentMat <- table(assignmentTable[,"geneSet"], assignmentTable[,"cell"])
assignmentMat[,1:2]

## ----assignHeatmap------------------------------------------------------------
set.seed(123)
miniAssigMat <- assignmentMat[,sample(1:ncol(assignmentMat),100)]
library(NMF)
aheatmap(miniAssigMat, scale="none", color="black", legend=FALSE)

## ----assignHeatmap_interactive, eval=FALSE------------------------------------
# # if (!requireNamespace("d3heatmap", quietly = TRUE)) BiocManager::install("d3heatmap")
# # d3heatmap(matrix(miniAssigMat), scale="none", colors=c("white", "black"))
# 
# library(DT)
# datatable(assignmentTable, options = list(pageLength = 10), filter="top")

## ----loadtSNE, fig.width=4, fig.height=4--------------------------------------
# Load the tSNE (included in the package)
load(paste(file.path(system.file('examples', package='AUCell')), "cellsTsne.RData", sep="/"))
cellsTsne <- cellsTsne$Y
plot(cellsTsne, pch=16, cex=.3)

## ----runTsne, eval=FALSE------------------------------------------------------
# load("exprMatrix_AUCellVignette_MouseBrain.RData")
# sumByGene <- apply(mouseBrainExprMatrix, 1, sum)
# exprMatSubset <- mouseBrainExprMatrix[which(sumByGene>0),]
# logMatrix <- log2(exprMatSubset+1)
# logMatrix <- as.matrix(logMatrix)
# 
# library(Rtsne)
# set.seed(123)
# cellsTsne <- Rtsne(t(logMatrix))
# rownames(cellsTsne$Y) <- colnames(logMatrix)
# colnames(cellsTsne$Y) <- c("tsne1", "tsne2")
# save(cellsTsne, file="cellsTsne.RData")

## ----plotTsneCode, fig.width=7, fig.height=6----------------------------------
selectedThresholds <- getThresholdSelected(cells_assignment)
par(mfrow=c(2,3)) # Splits the plot into two rows and three columns
for(geneSetName in names(selectedThresholds)[1:6])
{
  nBreaks <- 5 # Number of levels in the color palettes
  # Color palette for the cells that do not pass the threshold
  colorPal_Neg <- grDevices::colorRampPalette(c("black","blue", "skyblue"))(nBreaks)
  # Color palette for the cells that pass the threshold
  colorPal_Pos <- grDevices::colorRampPalette(c("pink", "magenta", "red"))(nBreaks)
  
  # Split cells according to their AUC value for the gene set
  passThreshold <- getAUC(cells_AUC)[geneSetName,] >  selectedThresholds[geneSetName]
  if(sum(passThreshold) >0 )
  {
    aucSplit <- split(getAUC(cells_AUC)[geneSetName,], passThreshold)
    
    # Assign cell color
    cellColor <- c(setNames(colorPal_Neg[cut(aucSplit[[1]], breaks=nBreaks)], names(aucSplit[[1]])), 
    setNames(colorPal_Pos[cut(aucSplit[[2]], breaks=nBreaks)], names(aucSplit[[2]])))
    
    # Plot
    plot(cellsTsne, main=geneSetName,
    sub="Pink/red cells pass the threshold",
    col=cellColor[rownames(cellsTsne)], pch=16) 
  }
}

## ----tsneThreshold------------------------------------------------------------
selectedThresholds[2] <-  0.25
par(mfrow=c(2,3))
AUCell_plotTSNE(tSNE=cellsTsne, exprMat=exprMatrix, 
cellsAUC=cells_AUC[1:2,], thresholds=selectedThresholds)

## -----------------------------------------------------------------------------
logMat <- log2(exprMatrix+2)
meanByGs <- t(sapply(geneSets, function(gs) colMeans(logMat[geneIds(gs),])))
rownames(meanByGs) <- names(geneSets)

## ----meanTsne, fig.width=7, fig.height=8--------------------------------------
colorPal <- grDevices::colorRampPalette(c("black", "red"))(nBreaks)
par(mfrow=c(3,3))
for(geneSetName in names(geneSets))
{
  cellColor <- setNames(colorPal[cut(meanByGs[geneSetName,], breaks=nBreaks)], names(meanByGs[geneSetName,]))
  plot(cellsTsne, main=geneSetName, axes=FALSE, xlab="", ylab="",
  sub="Expression mean",
  col=cellColor[rownames(cellsTsne)], pch=16)
}

AUCell_plotTSNE(tSNE=cellsTsne, exprMat=exprMatrix, plots = "AUC",
cellsAUC=cells_AUC[1:9,], thresholds=selectedThresholds)

## ----fig.height=4, fig.width=3.5----------------------------------------------
nGenesPerCell <- apply(exprMatrix, 2, function(x) sum(x>0))
colorPal <- grDevices::colorRampPalette(c("darkgreen", "yellow","red"))
cellColorNgenes <- setNames(adjustcolor(colorPal(10), alpha.f=.8)[as.numeric(cut(nGenesPerCell,breaks=10, right=FALSE,include.lowest=TRUE))], names(nGenesPerCell))
plot(cellsTsne, axes=FALSE, xlab="", ylab="",
sub="Number of detected genes",
col=cellColorNgenes[rownames(cellsTsne)], pch=16)

## -----------------------------------------------------------------------------
# "Real" cell type (e.g. provided in the publication)
cellLabels <- paste(file.path(system.file('examples', package='AUCell')), "mouseBrain_cellLabels.tsv", sep="/")
cellLabels <- read.table(cellLabels, row.names=1, header=TRUE, sep="\t")

## -----------------------------------------------------------------------------
# Confusion matrix:
cellTypeNames <- unique(cellLabels[,"level1class"])
confMatrix <- t(sapply(cells_assignment[c(1,4,2,5,3,6:9)], 
function(x) table(cellLabels[x$assignment,])[cellTypeNames]))
colnames(confMatrix) <- cellTypeNames
confMatrix[which(is.na(confMatrix), arr.ind=TRUE)] <- 0
confMatrix

## -----------------------------------------------------------------------------
date()
sessionInfo()

# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
dim(exprMatrix)
##################################################

############# Begining of the workflow ###########
# Step 1.
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=FALSE)

# Step 2.
# (Gene set: 10 random genes)
genes <- sample(rownames(exprMatrix), 10)
geneSets <- list(geneSet1=genes)
# (aucMaxRank=5 to run with this fake example, it will return 'high' AUC values)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)
##################################################

# Plot histogram:
AUCell_plotHist(cells_AUC["geneSet1",], nBreaks=10)

# Aux function for AUCell.assignCells
#' @importFrom stats sd
#' @importFrom stats ks.test
#' @importFrom stats rnorm
#' @importFrom stats qnorm
#' @importFrom stats dnorm
#' @importFrom stats density
#' @importFrom utils installed.packages
#' @importFrom utils capture.output
#' @importFrom graphics lines
#' @importFrom graphics points
#' @importFrom graphics hist
#' @importFrom graphics rect
#' @importFrom graphics abline
#' @importFrom graphics text

#### This version:
####    - AUC calculation, same as always,
####    - Threshold: Testing diferent thresholds
####       (3 versions are calculated, and the maximum is chosen automatically)
####    TO DO: decide what to do with global distr (i.e. for HK...)

# V6: smallestPopPercent renamed
# auc <- cells_AUC[,5] # grep("regulation of stress", colnames(AUCell.auc))
.auc_assignmnetThreshold_v6 <- function(aucRow, plotHist=TRUE,
          smallestPopPercent=.25, densAdjust=2, thrP=0.01, nBreaks=100)
{
  gSetName <- rownames(aucRow)[1]
  auc <- aucRow[gSetName,]


  nCells <- length(auc)
  skipGlobal <- TRUE
  skipRed <- FALSE
  skipSmallDens <- FALSE
  commentMsg <- ""
  aucThrs <- c()

  notPopPercent <- 1 - smallestPopPercent
  highValCells <- signif(sum(auc > 0.20)/length(auc),2)
  if(highValCells < 0.05)
  {
    # skipGlobal <- FALSE
    commentMsg <- paste0(commentMsg,
               "Few cells have high AUC values (",highValCells,"% cells with AUC> 0.20). ", sep="")
  }
  
  if(sum(auc==0) > (nCells*notPopPercent))
  {
    skipGlobal <- FALSE
    commentMsg <- paste0(commentMsg,
                 round((sum(auc==0)/nCells)*100),
                 "% (more than ", notPopPercent,"%) of AUC are zero. ", sep="")
  }
  
  
  
  

  meanAUC <- mean(auc)
  sdAUC <- sd(auc)
  maybeNormalDistr <- !suppressWarnings(
    ks.test(auc, rnorm(max(100,length(auc)),mean=meanAUC, sd = sdAUC),
            alternative = "less")$p.value < .01)
  if(maybeNormalDistr){
    commentMsg <- paste0(commentMsg,
            "The AUC might follow a normal distribution (random gene-set?). ")
    skipGlobal <- FALSE

    # aucThrs["outlierOfGlobal"] <- meanAUC + 2*sdAUC
    aucThrs["outlierOfGlobal"] <- qnorm(1-(thrP/nCells), mean=meanAUC, sd=sdAUC)
  }

  #V6
  histogram <- hist(c(0, auc/max(auc)), breaks=100, plot=FALSE)$count
  if((sum(histogram[1:5]) / sum(histogram)) >= notPopPercent*.75) {
    skipGlobal <- FALSE
    skipRed <- TRUE
    skipSmallDens <- TRUE
  }
  if((sum(histogram[1:10]) / sum(histogram)) >= notPopPercent*.50) {
    skipSmallDens <- TRUE
    skipGlobal <- FALSE
    # skipRed <- TRUE ?
    aucThrs["tenPercentOfMax"] <- max(auc)*.10
  }
  # print(skipRed)

  densCurve <- density(auc, adjust=densAdjust, cut=0)
  maximumsDens <- NULL
  inflPoints <- diff(sign(diff(densCurve$y)))
  maximumsDens <- which(inflPoints==-2)
  globalMax <- maximumsDens[which.max(densCurve$y[maximumsDens])]
  minimumDens <- which(inflPoints==2)
  smallMin <- NULL
  if(!skipSmallDens)
    smallMin <- data.table::last(minimumDens[which(minimumDens < globalMax)]) #1prev to max
  minimumDens <- c(smallMin,
        minimumDens[which(minimumDens > globalMax)]) # all after maximum

  # Density-based threshold (V4):
  # First minimum after the biggest maximum   (adjust=2)
  densTrh <- NULL
  if(length(minimumDens)>0) # && (!skipMinimumDens))
  {
    densTrh <- densCurve$x[min(minimumDens)]
    # Commented on V6
    # Only keep if it is a real inflextion point
    # (i.e. next max at least 5% of the global max)
    if(length(maximumsDens)>0)
    {
      nextMaxs <- maximumsDens[which(densCurve$x[maximumsDens] > densTrh)]
      if((max(densCurve$y[nextMaxs])/max(densCurve$y))<.05)
      {
        densTrh <- NULL
        # print(gSetName)
      }
    }
  }

  ## TO DO: Check special cases with many zeroes
  auc <- sort(auc)
  distrs <- list()
  distrs[["Global_k1"]] <- list(mu=c(meanAUC, NA), sigma=c(sdAUC, NA), x=auc)


  if("mixtools" %in% rownames(installed.packages()))
  {
    na <- capture.output(distrs[["k2"]] <-
        tryCatch(mixtools::normalmixEM(auc, fast=FALSE, k=2, verb=FALSE),
        # With fast, if there are many zeroes, it fails quite often
        error = function(e) {
          return(NULL)
        }))

    na <- capture.output(distrs[["k3"]] <-
        tryCatch(mixtools::normalmixEM(auc, fast=FALSE, k=3, verb=FALSE),
        error = function(e) {
          return(NULL)
        }))

    if(is.null(distrs[["k2"]]) && is.null(distrs[["k3"]]))
    {
      if(sum(auc==0)<(nCells*notPopPercent*.5))
        skipGlobal <- FALSE    # only if not too many zeroes??
      # qpois(1-(thrP/nCells), 1, log = FALSE)
      # plot(sort(rpois(auc, lambda=var(auc)), decreasing=TRUE))

      # commented V6 why was it here??
      # qPop <- quantile(auc, 1-smallestPopPercent)
      # if(sum(auc<qPop) >0)
      #   distrs[["k2"]] <- list(mu=c(mean(auc[auc<qPop]), NA),
      #                          sigma=c(sd(auc[auc<qPop]), NA),
      #                          lambda=c(1,NA), x=auc)
    }
    # if(!skipGlobal) print(gSetName) Warning?

    if(!is.null(distrs[["k2"]]))
    {
      compL <- which.min(distrs[["k2"]][["mu"]])
      compR <- which.max(distrs[["k2"]][["mu"]])
      ### Check distributions
      # Second distribution is "taller" than first one
      height1 <- .4/distrs[["k2"]][["sigma"]][compL]*
        distrs[["k2"]][["lambda"]][compL]
      height2 <- .4/distrs[["k2"]][["sigma"]][compR]*
        distrs[["k2"]][["lambda"]][compR]
      taller <- height1 < height2
      # Use global distr:
      # Mean of the global distr is included within the SD of the first
      # & Both means are included within the mean+SD of the Global distribution
      globalInclInFirst <-
        (distrs[["Global_k1"]]$mu[1] <
        (distrs[["k2"]][["mu"]][compL]+(1.5*distrs[["k2"]][["sigma"]][compL])))
      includedInGlobal <-
        ((distrs[["k2"]][["mu"]][compL] >
        (distrs[["Global_k1"]]$mu[1]-distrs[["Global_k1"]]$sigma[1])) &&
          (distrs[["k2"]][["mu"]][compR] <
          (distrs[["Global_k1"]]$mu[1]+distrs[["Global_k1"]]$sigma[1])))
      if(taller || (globalInclInFirst && includedInGlobal))
      {
        skipGlobal <- FALSE

        if(globalInclInFirst && includedInGlobal)
          commentMsg <- paste0(commentMsg,
                "The global distribution overlaps the partial distributions. ")
        if(taller && !includedInGlobal)
          commentMsg <- paste0(commentMsg, "The right distribution is taller. ")
      }
    }
  }else{
    warning("Package 'mixtools' is not available to calculate the sub-distributions.")
  }

  # stop()
  # print(paste(gSetName, '---here'))
  glProb <- 1-(thrP/nCells + smallestPopPercent)   ## CORRECT?!?!
  aucThrs["Global_k1"] <- qnorm(glProb,# qnorm(1-(thrP/nCells),
                                mean=distrs[["Global_k1"]][["mu"]][1],
                                sd=distrs[["Global_k1"]][["sigma"]][1])
  if(!is.null(distrs[["k2"]]))
  {
    k2_L <- which.min(distrs[["k2"]][["mu"]]) # (sometimes the indexes are shifted)
    aucThrs["L_k2"] <- qnorm(1-(thrP/nCells),
                             mean=distrs[["k2"]][["mu"]][k2_L],
                             sd=distrs[["k2"]][["sigma"]][k2_L])
  }

  if(!is.null(distrs[["k3"]]))
  {
    k3_R <- which.max(distrs[["k3"]][["mu"]]) # R: right distribution
    k3_R_threshold <- qnorm(thrP,
                            mean=distrs[["k3"]][["mu"]][k3_R],
                            sd=distrs[["k3"]][["sigma"]][k3_R])
    if(k3_R_threshold > 0) aucThrs["R_k3"] <- k3_R_threshold
  }

  if(!is.null(densTrh))
  {
    aucThrs["minimumDens"] <- densTrh
  }

  aucThr <- aucThrs
  if(skipGlobal)
    aucThr <- aucThrs[which(!names(aucThrs) %in% "Global_k1")]
    # TO DO: Decide when to merge with GLOBAL

  if(skipRed)
    aucThr <- aucThrs[which(!names(aucThrs) %in% "L_k2")]
    # TO DO: Decide when to merge with GLOBAL

  aucThr <- aucThr[which.max(aucThr)] # to keep name
  if((length(aucThr)>0) && (names(aucThr) == "minimumDens"))
  {
    maximumsDens <- maximumsDens[which(densCurve$y[maximumsDens]>1)]
    if(length(maximumsDens) > 2)
    {
      tmp <- cbind(minimumDens[seq_len(length(maximumsDens)-1)],
                   maximumsDens[-1])
      FCs <- densCurve$y[tmp[,2]]/densCurve$y[tmp[,1]]
      if(any(FCs > 1.5))
        warning(gSetName,
          ":\tCheck the AUC histogram. ",
          "'minimumDens' was selected as the best threshold, ",
          "but there might be several distributions in the AUC.")
    }
  }

  if("minimumDens" %in% names(aucThrs))
    aucThr <- aucThrs["minimumDens"]
  if(length(aucThr)==0)
    aucThr <- aucThrs[which.max(aucThrs)]
  if(length(aucThr)==0) #should not happen
    aucThr <- 1
  if(length(aucThr)>1) #should not happen
    aucThr <- unlist(aucThr[which.max(aucThr)])
    

  if(plotHist)
  {
    histInfo <- AUCell_plotHist(aucRow,
                         aucThr=aucThr,
                         nBreaks=nBreaks)
    histMax <- max(histInfo[[gSetName]]$counts)

    # Plot density
    densCurve$y <- densCurve$y*(histMax/max(densCurve$y))
    thisLwd <- ifelse(
      (aucThrs["minimumDens"]==aucThr) &&
        (!is.null(aucThr) && !is.null(aucThrs["minimumDens"])),
      3,
      1)
    lines(densCurve, lty=1, lwd=thisLwd, col="blue")
    if(!is.null(minimumDens))
      points(densCurve$x[minimumDens], densCurve$y[minimumDens],
             pch=16, col="darkblue")

    ### Plot distributions
    scalFact <- 1
    # if(!skipGlobal)
    # {
    aucDistr <- dnorm(distrs[["Global_k1"]][["x"]],
                      mean=distrs[["Global_k1"]][["mu"]][1],
                      sd=distrs[["Global_k1"]][["sigma"]][1])
    scalFact <- (histMax/max(aucDistr))*.95

    thisLwd <- ifelse(aucThrs["Global_k1"]==aucThr, 3, 1)
    lines(distrs[["Global_k1"]][["x"]],
          scalFact * aucDistr,
          col="darkgrey", lwd=thisLwd, lty=2)

    if(!is.null(distrs[["k2"]]))
    {
      aucDistr <- dnorm(distrs[["k2"]][["x"]],
                        mean=distrs[["k2"]][["mu"]][k2_L],
                        sd=distrs[["k2"]][["sigma"]][k2_L])
      scalFact <- (histMax/max(aucDistr))*.95


      thisLwd <- ifelse(aucThrs["k2"]==aucThr, 3, 1)
      lines(distrs[["k2"]][["x"]],
            scalFact * aucDistr,
            col="red", lwd=thisLwd, lty=2)

      rect(distrs[["k2"]][["mu"]][k2_L]-distrs[["k2"]][["sigma"]][k2_L],
           histMax-(histMax*.02),
           distrs[["k2"]][["mu"]][k2_L]+distrs[["k2"]][["sigma"]][k2_L],
           histMax, col="#70000030", border="#00009000")
    }

    # print(aucThrs)
    if((!is.null(distrs[["k3"]])) && ("R_k3" %in% names(aucThrs)))
    {
      k3_L <- which.min(distrs[["k3"]][["mu"]]) # (index position not constant)

      aucDistr2 <- dnorm(distrs[["k3"]][["x"]],
                         mean=distrs[["k3"]][["mu"]][k3_R],
                         sd=distrs[["k3"]][["sigma"]][k3_R])
      scalFact2 <- scalFact *
        (distrs[["k3"]][["lambda"]][k3_R]/distrs[["k3"]][["lambda"]][k3_L])

      thisLwd <- ifelse(aucThrs["k3"]==aucThr, 3, 1)
      lines(distrs[["k3"]][["x"]],
            scalFact2*aucDistr2,
            col="magenta", lwd=thisLwd, lty=2)

      rect(distrs[["k3"]][["mu"]][k3_R]-distrs[["k3"]][["sigma"]][k3_R],
           histMax-(histMax*.02),
           distrs[["k3"]][["mu"]][k3_R]+distrs[["k3"]][["sigma"]][k3_R],
           histMax, col="#80808030", border="#80808030")
    }

    ## Add threshold lines
    aucThrs <- aucThrs[!is.na(aucThrs)]
    if(length(aucThrs)>0)
    {
      pars <- list()
      pars[["Global_k1"]] <- c(col1="#909090", col2="black", pos=.9)
      pars[["L_k2"]] <- c(col1="red", col2="darkred", pos=.8)
      # pars[["Max"]] <- c(col1="grey", col2="black", pos=.4)
      pars[["R_k3"]] <- c(col1="magenta", col2="magenta", pos=.6)
      pars[["minimumDens"]] <- c(col1="blue", col2="darkblue", pos=.4)
      pars[["tenPercentOfMax"]] <- c(col1="darkgreen", col2="darkgreen", pos=.9)
      pars[["outlierOfGlobal"]] <- c(col1="darkgreen", col2="darkgreen", pos=.9)

      for(thr in names(aucThrs))
      {
        thisLwd <- ifelse(aucThrs[thr]==aucThr, 5, 2)
        thisLty <- ifelse(aucThrs[thr]==aucThr, 1, 3)

        abline(v=aucThrs[thr], col=pars[[thr]][1], lwd=thisLwd, lty=thisLty)
        xPos <- aucThrs[thr]*1.01
        if(aucThrs[thr] > (max(auc)*.8))
          xPos <- 0
        if(aucThrs[thr]==aucThr)
          text(xPos, histMax*as.numeric(pars[[thr]][3]),
               pos=4, col=pars[[thr]][2], cex=.8,
               paste("AUC > ", signif(aucThrs[thr],2),
                     "\n(",sum(auc>aucThrs[thr])," cells)", sep=""))
      }
    }
  }
  return(list(selected=aucThr,
       thresholds=cbind(threshold=aucThrs,
                        nCells=sapply(aucThrs, function(x) sum(auc>x))),
       comment=commentMsg))
}

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @title Plot AUC histogram
#' @description Plots the distribution of AUC across the cells
#' (for each gene-set) as an histogram.
#' @param cellsAUC Subset of the object returned by \code{\link{AUCell_calcAUC}}
#' (i.e. including only the gene-sets to plot)
#' @param aucThr AUC value planned to use as threshold
#' (to make sure the X axis includes it), if any.
#' Otherwise, the X axis extends to cover only the AUC values plotted.
#' @param nBreaks Number of 'bars' to plot (breaks argument for hist function).
#' @param onColor Color for the bars that pass the AUC threshold
#' @param offColor Color for the bars that do not pass the AUC threshold
#' @param ... Other arguments to pass to \code{\link{hist}} function.
#' @return List of histogram objects (invisible).
#' @seealso See the package vignette for examples and more details:
#' \code{vignette("AUCell")}
#' @example inst/examples/example_AUCell_plotHist.R
#' @export
AUCell_plotHist <- function(cellsAUC, aucThr=max(cellsAUC), nBreaks=100, 
                            onColor="dodgerblue4", offColor="slategray2", ...)
{
  if(methods::is(cellsAUC,"aucellResults")) {
    cellsAUC <- getAUC(cellsAUC)
  }
  if(!is.matrix(cellsAUC))
    stop("The first argument should be the output from 'AUCell_calcAUC()'")

  ret <- lapply(seq_len(nrow(cellsAUC)), function(gsn) {
    .auc_plotHist(auc=cellsAUC[gsn,], gSetName=rownames(cellsAUC)[gsn],
              aucThr=aucThr, nBreaks=nBreaks, 
              onColor=onColor, offColor=offColor, ...)
    })
  names(ret) <- rownames(cellsAUC)

  invisible(ret)
}
# @export
#AUCell_plot <- AUCell_plotHist # Alias (backwards compatibility) TO DO: Replace by conditional?

# only for one gene-set
.auc_plotHist <- function(auc, gSetName, aucThr, 
                        nBreaks=100, 
                        onColor="dodgerblue4", offColor="slategray2", 
                        ...)
{
  maxLim <- max(c(auc, aucThr), na.rm=T)
  # col <- rep("lightskyblue2", nBreaks)
  # col[passThr] <- "dodgerblue2"
  col <- rep(offColor, nBreaks)
  borderCol <- rep("lightsteelblue1", nBreaks)
  passThr <- hist(auc, breaks=nBreaks, plot=FALSE)$breaks >= aucThr
  col[passThr] <- onColor
  borderCol[passThr] <- "cornflowerblue"
  
  ret <- hist(auc, breaks=nBreaks, xlim=c(0,maxLim),
    col=col, border=borderCol,
    main=gSetName, xlab="AUC histogram", ...)
  return(ret)
}

# Default plots for binary and AUC are available in priv_plots.R

## AUCell_plot()
##
# Input:
# Output:

test_AUCell_plotHist <- function()
{
  # TO DO: add tests for _plotTsne()s
  library(AUCell)
  ##################################################
  # Previous steps
  set.seed(123)
  exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                       nrow=20)
  rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
  colnames(exprMatrix) <- paste("Cell", 1:500, sep="")

  cells_rankings <- suppressWarnings(AUCell_buildRankings(exprMatrix, plotStats=FALSE, verbose=FALSE))
  fewGenes <- sample(rownames(exprMatrix), 10)
  cellsAUC <- suppressWarnings(AUCell_calcAUC(fewGenes, cells_rankings, aucMaxRank=5))
  ##################################################

  testthat::expect_equal(length(AUCell_plotHist(cellsAUC)), 1)
  testthat::expect_equal(length(AUCell_plotHist(cellsAUC[1,])), 1)
}

test_that("AUCell_plotHist tests", test_AUCell_plotHist())

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)
#
#' @title AUCell_exploreThresholds
#' @description Plots all the AUC histograms (per gene-set)
#' and calculates several likely thresholds for each gene-set
#' @param cellsAUC AUC object returned by \code{\link{AUCell_calcAUC}}.
#' @param thrP Probability to determine outliers in some of the distributions
#'  (see 'details' section).
#'
#' By default it is set to 1\% (thrP):
#' if there are 3000 cells in the dataset,
#' it is expected that approximately 30 cells are over this threshold
#' if the AUC is normally distributed.
#' @param nCores Number of cores to use for computation.
#' @param smallestPopPercent Size (percentage) of the smallest population
#' of cells expected. Used to calculate some of the thresholds.
#' @param plotHist Whether to plot the AUC histograms. (TRUE / FALSE)
#' @param densAdjust Parameter for the density curve. (See \code{density} for details).
#' @param assignCells Return the list of cells that pass the
#' automatically selected threshold? (TRUE/FALSE)
#' @param nBreaks Number of bars to plot in the histograms.
#' @param verbose Should the function show progress messages? (TRUE / FALSE)
#' @param aucellThresholds For aux functions: Output from AUCell_exploreThresholds
#' @return List with the following elements for each gene-set:
#' \itemize{
#' \item 'aucThr' Thresholds calculated with each method (see 'details' section),
#' and the number of cells that would be assigned using that threshold.
#'
#' If assignCells=TRUE, the threshold selected automatically is the highest
#' value (in most cases, excluding the global distribution).
#' \item 'assignment' List of cells that pass the selected AUC threshold (if \code{assignCells=TRUE})
#' }
#' If \code{plotHist=TRUE} the AUC histogram is also plot,
#' including the distributions calculated and the corresponding thresholds
#' in the same color (dashed vertical lines).
#' The threshold that is automatically selected is shown as a thicker
#'  non-dashed vertical line.
#'
#' @details To ease the selection of an assignment theshold,
#' this function adjusts the AUCs of each gene-set to several distributions
#'  and calculates possible thresholds:
#' \itemize{
#' \item \code{minimumDens} (plot in Blue):
#' Inflection point of the density curve.
#' This is usually a good option for the ideal situation
#' with bimodal distributions.
#'
#' To avoid false positives, by default this threshold will not be chosen
#' if the second distribution is higher
#' (i.e. the majority of cells have the gene-set "active").
#' \item \code{L_k2} (plot in Red): Left distribution,
#' after adjusting the AUC to a mixture of two distributions.
#' The threshold is set to the right (prob: \code{1-(thrP/nCells)}).
#' Only available if 'mixtools' package is installed.
#' \item \code{R_k3} (plot in Pink): Right distribution,
#' after adjusting the AUC to a mixture of three distributions.
#' The threshold is set to the left (prob: \code{thrP}).
#' Only available if 'mixtools' package is installed.
#' \item \code{Global_k1} (plot in Grey): "global" distribution
#'(i.e. mean and standard deviations of all cells).
#'The threshold is set to the right (prob: \code{1-(thrP/nCells)}).
#'
#' The threshold based on the global distribution is ignored from the automatic
#' selection unless the mixed models are overlapping.
#' }
#' Note: If \code{assignCells=TRUE}, the highest threshold is used to select cells.
#' However, keep in mind that this function is only meant to ease the selection
#' of the threshold, and we highly recommend to look at the AUC histograms and
#' adjust the threshold manually if needed.
#' We recommend to be specially aware on gene-sets with few genes (10-15) and
#' thresholds that are set extremely low.
#'
#' @seealso Previous step in the workflow: \code{\link{AUCell_calcAUC}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("AUCell")}
#' @example inst/examples/example_AUCell_exploreThresholds.R
#' @export


# Runs .auc_assignmnetThreshold on each gene set (AUC)
AUCell_exploreThresholds <- function(cellsAUC, thrP=0.01, nCores=1,
     smallestPopPercent=.25, plotHist=TRUE, densAdjust=2, assignCells=FALSE,
     nBreaks=100, verbose=TRUE) # nDist=NULL,
{
  aucMatrix <- NULL
  if(methods::is(cellsAUC,"aucellResults")){
    aucMatrix <- getAUC(cellsAUC)
  }
  
  if(methods::is(cellsAUC,"matrixWrapper"))
  {
    stop('The AUC was calculated with a previous AUCell version. \n",
         "Please update them with updateAucellResults(..., objectType="AUC")')
  }

  if(is.matrix(cellsAUC)) {
    aucMatrix <- cellsAUC
  }
  if(!is.matrix(aucMatrix)) stop("cellsAUC should contain the AUC values.")
  
  rowSumAUC <- rowSums(aucMatrix)
  if(any(rowSumAUC==0)) warning("Skipping genesets with all AUC 0: ", 
                                paste(names(rowSumAUC)[which(rowSumAUC==0)], collapse=", "), 
                                immediate. = TRUE)
  aucMatrix <- aucMatrix[rowSumAUC>0,,drop=FALSE]

  if(nCores > 1 && plotHist) {
    nCores <- 1
    warning("Cannot plot in paralell")
  }

  if(nCores==1)
  {
    gSetName <- NULL
    assigment <- lapply(rownames(aucMatrix), function(gSetName)
    {
      aucThr <- .auc_assignmnetThreshold_v6(
                      aucRow=aucMatrix[gSetName,, drop=FALSE],
                      thrP=thrP,
                      smallestPopPercent=smallestPopPercent,
                      plotHist=plotHist,
                      densAdjust=densAdjust,
                      nBreaks=nBreaks)
      assignedCells <- NULL
      if(!is.null(aucThr)){
        auc <- aucMatrix[gSetName,]
        assignedCells <- names(auc)[which(auc>aucThr$selected)]
      }

      list(aucThr=aucThr, assignment=assignedCells)

    })
    names(assigment) <- rownames(aucMatrix)

  }else
  {
    # Run each geneSet in parallel
    doRNG::registerDoRNG(nCores)
    if(verbose)
      message("Using ", foreach::getDoParWorkers(), " cores.")

    "%dopar%"<- foreach::"%dopar%"
    suppressPackageStartupMessages(assigment <-
              doRNG::"%dorng%"(foreach::foreach(gSetName=rownames(aucMatrix)),
    {
      aucThr <- .auc_assignmnetThreshold_v6(
                          aucRow=aucMatrix[gSetName,, drop=FALSE],
                          thrP=thrP,
                          smallestPopPercent=smallestPopPercent,
                          plotHist=plotHist,
                          densAdjust=densAdjust,
                          nBreaks=nBreaks)
      assignedCells <- NULL
      if(!is.null(aucThr)){
        auc <- aucMatrix[gSetName,]
        assignedCells <- names(auc)[which(auc>aucThr$selected)]
      }
      tmp <- list(aucThr=aucThr, assignment=assignedCells)
      return(setNames(list(tmp), gSetName))
    }))
    attr(assigment, "rng") <- NULL
    assigment <- unlist(assigment, recursive = FALSE)[rownames(aucMatrix)]
  }
  # If cell assignment is not requested, remove from the output
  # (it was initially calculated to know the number of cells)
  if(!assignCells)
    assigment <- lapply(assigment, function(x)
      x[which(!names(x) %in% "assignment")])

  return(assigment)
}

## AUCell_plot()
##
# Input:
# Output:

test_AUCell_exploreThresholds <- function()
{
  library(AUCell)
  ##################################################
  # Previous steps
  set.seed(123)
  exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                       nrow=20)
  rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
  colnames(exprMatrix) <- paste("Cell", 1:500, sep="")

  cells_rankings <- suppressWarnings(AUCell_buildRankings(exprMatrix, plotStats=FALSE, verbose=FALSE))
  geneSets <- GSEABase::GeneSetCollection(list(
    GSEABase::GeneSet(sample(rownames(exprMatrix), 10), setName="gs1"),
    GSEABase::GeneSet(sample(rownames(exprMatrix), 10), setName="gs2")))
  cellsAUC <- suppressWarnings(AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5))
  ##################################################

  thresholds <- AUCell_exploreThresholds(cellsAUC, plotHist=FALSE)

  .check_AUCell_exploreThresholds(thresholds, geneSets)

  ### Multicore (fails check)
  # set.seed(123)
  # thresholds_multicore_1 <- AUCell_exploreThresholds(cellsAUC, plotHist=FALSE, nCores=2)
  # set.seed(123)
  # thresholds_multicore_2 <- AUCell_exploreThresholds(cellsAUC, plotHist=FALSE, nCores=2)
  #
  # testthat::expect_equal(thresholds_multicore_1, thresholds_multicore_2)
  .check_AUCell_exploreThresholds(thresholds, geneSets)
}

.check_AUCell_exploreThresholds <- function(thresholds, geneSets)
{
  testthat::expect_equal(length(thresholds), 2)
  testthat::expect_equal(names(thresholds), names(geneSets))
  testthat::expect_equal(names(thresholds[[1]]$aucThr), c("selected", "thresholds", "comment"))
}

test_that("AUCell_exploreThresholds tests", test_AUCell_exploreThresholds())

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @rawNamespace import(data.table, except = shift)
# @import SummarizedExperiment
#' @importFrom methods new
#' @importFrom DelayedMatrixStats colRanks
#' @importClassesFrom DelayedArray DelayedArray
#'
#' @title Build gene expression rankings for each cell
#' @description Builds the "rankings" for each cell:
#' expression-based ranking for all the genes in each cell.
#'
#' The genes with same expression value are shuffled.
#' Therefore, genes with expression '0' are randomly sorted at the
#' end of the ranking.
#'
#' These "rankings" can be seen as a new representation of the original dataset.
#' Once they are calculated, they can be saved for future analyses.
#' @param exprMat Expression matrix (genes as rows, cells as columns)
#' The expression matrix can also be provided as one of the R/Bioconductor classes:
#' \itemize{
#' \item \link[Matrix]{dgCMatrix-class}:
#' Sparse matrix 
#' \item \link{RangedSummarizedExperiment} and derived classes (e.g. \link[SingleCellExperiment]{SingleCellExperiment} ):
#' The matrix will be obtained through assay(exprMatrix),
#' -which will extract the first assay (usually the counts)-
#' or the assay name given in 'assayName'
#' \item \code{ExpressionSet}:
#' The matrix will be obtained through exprs(exprMatrix)
#' }
#' @param featureType Name for the rows (e.g. "genes"). Only for naming the rankings, not used internally.
#' @param plotStats Should the function plot the expression boxplots/histograms?
#' (TRUE / FALSE). These plots can also be produced
#' with the function \code{\link{plotGeneCount}}.
#' @param splitByBlocks Whether to split the matrix by blocks in the ranking calculation. 
#' Allows using multiple cores.
#' FALSE by default. If using sparse matrices it is automatically set to TRUE.
#' @param BPPARAM Set to use multiple cores. Only used if 'splitByBlocks=TRUE'
#' @param verbose Should the function show progress messages? (TRUE / FALSE)
#' @param assayName Name of the assay containing the expression matrix (e.g. in \link[SingleCellExperiment]{SingleCellExperiment} objects)
#' @param keepZeroesAsNA Convert zeroes to NA instead of locating randomly at the end of the ranking.
#' @param ... Other arguments
#' @param nCores Deprecated
#' @param mctype Deprecated
#' @return Ranking of the feature within the cell (features as rows, cells as columns)
#' @details
#' It is important to check that most cells have at least the number of
#' expressed/detected genes that are going to be used to calculate the AUC
#' (`aucMaxRank` in `calcAUC()`).
#' The histogram provided by `AUCell_buildRankings()`
#' allows to quickly check this distribution.
#' `plotGeneCount(exprMatrix)` allows to obtain only the plot before
#' building the rankings.
#' @seealso Next step in the workflow: \code{\link{AUCell_calcAUC}}.
#'
#' See the package vignette for examples and more details:
#' \code{vignette("AUCell")}
#' @example inst/examples/example_AUCell_buildRankings.R
#' @rdname AUCell_buildRankings
#' @export
setGeneric("AUCell_buildRankings", signature="exprMat",
  function(exprMat, featureType="genes", plotStats=TRUE, splitByBlocks=FALSE,
           BPPARAM=NULL,
           keepZeroesAsNA=FALSE, verbose=TRUE, 
           nCores=NULL, mctype=NULL, ...)
  {
   standardGeneric("AUCell_buildRankings")
  })

# Sparse matrix
#' @rdname AUCell_buildRankings
#' @aliases AUCell_buildRankings,dgCMatrix-method
setMethod("AUCell_buildRankings", "dgCMatrix",
          function(exprMat, featureType="genes", plotStats=TRUE, splitByBlocks=TRUE,
                   BPPARAM=NULL,
                   keepZeroesAsNA=FALSE, verbose=TRUE, nCores=NULL, mctype=NULL)
          {
            .AUCell_buildRankings(exprMat=exprMat, featureType=featureType,
                                  splitByBlocks=TRUE, BPPARAM=BPPARAM,
                                  plotStats=plotStats, keepZeroesAsNA=keepZeroesAsNA, verbose=verbose,
                                  nCores=nCores, mctype=mctype)
          })

# Non-sparse matrix
#' @rdname AUCell_buildRankings
#' @aliases AUCell_buildRankings,matrix-method
setMethod("AUCell_buildRankings", "matrix",
  function(exprMat, featureType="genes", plotStats=TRUE, splitByBlocks=FALSE,
           BPPARAM=NULL,
           keepZeroesAsNA=FALSE, verbose=TRUE, 
           nCores=NULL, mctype=NULL)
  {
    .AUCell_buildRankings(exprMat=exprMat, featureType=featureType, 
                          splitByBlocks=splitByBlocks, BPPARAM=BPPARAM,
                          plotStats=plotStats, keepZeroesAsNA=keepZeroesAsNA, verbose=verbose,
                          nCores=nCores, mctype=mctype)
  })

#' @rdname AUCell_buildRankings
#' @aliases AUCell_buildRankings,ExpressionSet-method
setMethod("AUCell_buildRankings", "ExpressionSet",
          function(exprMat, featureType="genes", plotStats=TRUE, splitByBlocks=FALSE, 
                   BPPARAM=NULL,
                   keepZeroesAsNA=FALSE, verbose=TRUE, 
                   nCores=NULL, mctype=NULL)
          {
            exprMat <- Biobase::exprs(exprMat)
            .AUCell_buildRankings(exprMat=exprMat, featureType=featureType,
                                  splitByBlocks=splitByBlocks, BPPARAM=BPPARAM,
                                  plotStats=plotStats, keepZeroesAsNA=keepZeroesAsNA, verbose=verbose,
                                  nCores=nCores, mctype=mctype)
          })

#' @rdname AUCell_buildRankings
#' @aliases AUCell_buildRankings,SummarizedExperiment-method
setMethod("AUCell_buildRankings", "SummarizedExperiment",
function(exprMat, featureType="genes", plotStats=TRUE, splitByBlocks=FALSE,
         BPPARAM=NULL,
         keepZeroesAsNA=FALSE, verbose=TRUE, assayName=NULL, 
         nCores=NULL, mctype=NULL)
  {
    if(is.null(assayName))
    {
      if(length(SummarizedExperiment::assays(exprMat))>1)
        warning("More than 1 assays are available. Using the first one (", 
                names(assays(exprMat))[1], ").")
      
      exprMat <- SummarizedExperiment::assay(exprMat)
    }else{
      if(!assayName %in% names(assays(exprMat)))
        stop("There isn't an assay named ", assayName, ".")
      
      exprMat <- SummarizedExperiment::assays(exprMat)[[assayName]]
    }
    .AUCell_buildRankings(exprMat=exprMat, featureType=featureType, 
                          splitByBlocks=splitByBlocks, BPPARAM=BPPARAM,
                          plotStats=plotStats, keepZeroesAsNA=keepZeroesAsNA, verbose=verbose,
                          nCores=nCores, mctype=mctype)
  })


### Run without delayed array, it can be added outside if needed
# Accepts regular or sparse matrix ()
.AUCell_buildRankings <- function(exprMat, featureType="genes",
                                  splitByBlocks=FALSE,
                                  keepZeroesAsNA=FALSE, 
                                  BPPARAM=NULL,
                                  plotStats=TRUE, verbose=TRUE,
                                  nCores=NULL, mctype=NULL)
{
  if((!splitByBlocks) && ("dgCMatrix" %in% class(exprMat)))
    splitByBlocks <- TRUE
  
  if(!is.null(nCores))
      warning("nCores is no longer used. It will be deprecated in the next AUCell version.")
    
  ## Still needed? 
  if(keepZeroesAsNA){
    zeroesCoords <- which(exprMat==0, arr.ind=TRUE)
  }
  
  ## Calculate expression stats?
  nGenesDetected <- numeric(0)
  if(plotStats)
  {
    msg <- tryCatch(plotGeneCount(exprMat, plotStats=plotStats, verbose=verbose),
                    error = function(e) {
                      return(e)
                    })
    if(methods::is(msg,"error")) {
      warning("There has been an error in plotGeneCount() [Message: ",
              msg$message, "]. Proceeding to calculate the rankings...", sep="")
    }else{
      if(is.numeric(nGenesDetected))
        nGenesDetected <- msg
    }
  }
  
  ## Rank genes
  rowNames <- rownames(exprMat)
  colNames <- colnames(exprMat)
  exprMat <- -exprMat # ro rank decreasingly
  
  # Would prefer not to use the block inside the function... but
  # the method for sparse matrices does not allow ties.method='random'
  if(splitByBlocks){
    exprMat <- do.call(cbind,
                       blockApply(DelayedArray(exprMat),
                                  FUN=DelayedMatrixStats::colRanks,
                                  ties.method="random", preserveShape=TRUE,
                                  BPPARAM=BPPARAM,
                                  grid=colAutoGrid(exprMat))) 
  }else{
    exprMat <- DelayedMatrixStats::colRanks(exprMat, ties.method="random", preserveShape=TRUE, decreasing=TRUE) 
  }
  
  rownames(exprMat) <- rowNames
  colnames(exprMat) <- colNames
  
  if(keepZeroesAsNA){
    exprMat[which(zeroesCoords==0, arr.ind=TRUE)] <- NA
  }
  
  ## Format & return
  names(dimnames(exprMat)) <- c(featureType, "cells")
  new("aucellResults",
      SummarizedExperiment::SummarizedExperiment(assays=list(ranking=exprMat)),
      nGenesDetected=nGenesDetected)
}

# @import
#' @title Plot
#' @description  Plots the AUC histogram and t-SNE coloured by AUC, binary activity and TF expression
#' @importFrom graphics box legend plot
#' @importFrom grDevices adjustcolor dev.off png rainbow
#' @param tSNE t-SNE coordinates (e.g. \code{tSNE$Y})
#' @param exprMat Expression matrix
#' @param cellsAUC AUC (as returned by calcAUC)
#' @param thresholds Thresholds returned by AUCell
#' @param reorderGeneSets Whether to reorder the gene sets based on AUC similarity
#' @param cex Scaling factor for the dots in the scatterplot
#' @param alphaOn Transparency for the dots representing "active" cells
#' @param alphaOff Transparency for the dots representing "inactive" cells
#' @param borderColor Border color for the dots (scatterplot)
#' @param offColor Color for the dots representing "inactive" cells
#' @param plots Which plots to generate? Select one or multiple: \code{plots=c("histogram", "binaryAUC", "AUC", "expression")}
#' @param exprCols Color scale for the expression
#' @param asPNG Output each individual plot in a .png file? (can also be a directory)
#' @param ... Other arguments to pass to \code{\link{hist}} function.
#' @return Returns invisible: \code{cells_trhAssignment}
#' @details To avoid calculating thresholds, set thresholds to FALSE
#' @seealso List of vignettes included in the package: \code{vignette(package="AUCell")}
#' @example inst/examples/example_AUCell_plotTSNE.R
#' @export
# thresholds=NULL; cex=1; alphaOn=1; alphaOff=0.2;  offColor="lightgray"
# borderColor=adjustcolor("darkgrey", alpha.f=.3); plots=c("histogram", "binaryAUC", "AUC", "expression")
AUCell_plotTSNE <- function(tSNE, exprMat=NULL, cellsAUC=NULL, thresholds=NULL, 
                            reorderGeneSets=FALSE,
                            cex=1,
                            alphaOn=1, alphaOff=0.2,
                            borderColor=adjustcolor("lightgray", alpha.f=0.1),
                            offColor="lightgray",
                            plots=c("histogram", "binaryAUC", "AUC", "expression"),
                            exprCols= c("goldenrod1", "darkorange", "brown"),
                            asPNG=FALSE, ...)
{
  #library(BiocGenerics)
  #library(AUCell)
  ####################################
  # Check inputs (TO DO)
  if(is.null(rownames(tSNE))) stop("Please, provide the cell rownames in the t-SNE")
  if(!is.matrix(tSNE) | ncol(tSNE)!=2) stop("The t-SNE should be a matrix with 2 columns (cell coordinates)")
  if (any(grepl("binary", tolower(plots)))) {
    plots[grep("binary", tolower(plots))] <- "binaryAUC"
  }
  
  if(is.null(exprMat) && ("expression" %in% tolower(plots)))
  {
    plots <- plots[which(plots!="expression")]
    warning("Expression plot was requested, but no expression matrix provided.")
  }
  if(length(plots)==0) stop("Please, provide which plots to plot.")
  
  if(reorderGeneSets){
    cellsAUC <- cellsAUC[orderAUC(cellsAUC),]
  }
  
  ####################################
  # Calculate thresholds if needed
  if(is.logical(thresholds) && thresholds == FALSE) {
    thresholds <- FALSE #keep..
    if(any(grepl("binary", tolower(plots)))) stop("Cannot plot binary AUC without calculating the thresholds.")
  }else{
    if(!is.null(thresholds))
    {
      # if it is a list... probably return from AUCell. Let's try...
      if(is.list(thresholds[1])) {
        # Aucell
        if("aucThr" %in% names(thresholds[[1]])) thresholds <- sapply(thresholds, function(x) unname(x$aucThr$selected))
        # previous run of this function
        if("threshold" %in% names(thresholds[[1]]))  thresholds <- sapply(thresholds, function(x) unname(x$threshold))
      }
      
      if(!is.null(names(thresholds)))
      {
        geneSetNames <- rownames(cellsAUC)[which(rownames(cellsAUC) %in% names(thresholds))]
        cellsAUC <- cellsAUC[geneSetNames,]
      }
      if(is.null(names(thresholds)) || length(thresholds)==1)
      {
        thresholds <- setNames(rep(thresholds, nrow(cellsAUC)), rownames(cellsAUC))
      }
    }
  }
  
  if(!is.null(cellsAUC)){
    selectedGeneSets <- rownames(cellsAUC)
  }else{
    selectedGeneSets <- rownames(exprMat)
    plots <- "expression"
    # warning("no AUC provided... only plotting expression")
  }
  
  cells_trhAssignment <- list()
  
  ####################################
  # Start plots
  dirName <- "./"
  if(is.character(asPNG))
  {
    if(!file.exists(asPNG)) dir.create(asPNG)
    dirName <- paste0(asPNG,"/")
    asPNG <- TRUE
  }
  if(asPNG){
    nCols <- length(plots)
    figsMatrix <- matrix(nrow=length(selectedGeneSets), ncol=nCols)
    rownames(figsMatrix) <- selectedGeneSets
    colnames(figsMatrix) <- plots
  }
  
  for (geneSetName in selectedGeneSets)
  {
    ##################
    # Histogram
    # Calculate threshold?
    if(is.null(thresholds) && any(c("histogram", "binaryAUC") %in% plots))
    {
      if(asPNG & ("histogram" %in% tolower(plots))) {
        imgFile <- paste0(geneSetName,"_histogram.png")
        figsMatrix[geneSetName, "histogram"] <- imgFile # paste("<img src=\"", imgFile, "\") height=\"100\" alt=\"",imgFile, "\"></img>", sep = "")
        png(paste0(dirName, imgFile))
      }
      
      set.seed(123)
      cells_trhAssignment[[geneSetName]] <- AUCell_exploreThresholds(cellsAUC[geneSetName,], 
                                                                     assignCells=TRUE,
                                                                     plotHist=("histogram" %in% tolower(plots)))[[geneSetName]]
      thisTrheshold <- cells_trhAssignment[[geneSetName]]$aucThr$selected
      thisAssignment <- cells_trhAssignment[[geneSetName]]$assignment
      
      if(asPNG & ("histogram" %in% tolower(plots))) dev.off()
    }else
    {
      # Do NOT calculate threshold
      if("histogram" %in% tolower(plots))
      {
        if(asPNG) {
          imgFile <- paste0(geneSetName,"_histogram.png")
          figsMatrix[geneSetName, "histogram"] <- imgFile # paste("<img src=\"", imgFile, "\") height=\"100\" alt=\"",imgFile, "\"></img>", sep = "")
          png(paste0(dirName, imgFile))
        }
        
        ### Plot
        thisTrh <- as.vector(thresholds[geneSetName]) # TODO: Why needed sometimes? https://github.com/aertslab/AUCell/issues/3
        tmp <- .auc_plotHist(auc=getAUC(cellsAUC)[geneSetName,], gSetName=geneSetName,
                             aucThr=min(thisTrh, 1), nBreaks=100, sub="AUC")
        
        if(!is.null(thisTrh))
        {
          abline(v=thisTrh, lwd=3, lty=2, col="darkorange")
        }
        if(asPNG) dev.off()
      }
      
      cells_trhAssignment[[geneSetName]] <- NULL
      if(!is.null(cellsAUC))
      {
        thisTrheshold <- thresholds[geneSetName]
        if(is.matrix(cellsAUC)){
          matrixAUC <- cellsAUC
        }else{
          matrixAUC <- getAUC(cellsAUC)
        }
        thisAssignment <- names(which(matrixAUC[geneSetName,] > thisTrheshold))
        cells_trhAssignment[[geneSetName]] <- list("threshold"=thisTrheshold, "assignment"=thisAssignment) 
      }
    }
    
    ######### t-SNE 1: binary #############
    # Cells assigned at current threshold
    if(any(grepl("binary", tolower(plots))))
    {
      if(asPNG) {
        imgFile <- paste0(geneSetName,"_binaryAUC.png")
        figsMatrix[geneSetName, "binaryAUC"] <- imgFile # paste("<img src=\"", imgFile, "\") height=\"100\" alt=\"",imgFile, "\"></img>", sep = "")
        png(paste0(dirName, imgFile))
      }
      ### Plot
      thrAsTxt <- ""
      if(is.numeric(thisTrheshold)) thrAsTxt <- paste("Cells with AUC > ", signif(thisTrheshold, 2), sep="")
      .auc_plotBinaryTsne(tSNE, selectedCells=thisAssignment,
                          title=geneSetName, txt=thrAsTxt,
                          cex=cex, alphaOn=alphaOn, alphaOff=alphaOff,
                          borderColor=borderColor, offColor=offColor, ...)
      if(asPNG) dev.off()
    }
    
    ######### t-SNE 2: Continuous #############
    # Regulon AUC
    if("auc" %in% tolower(plots))
    {
      if(asPNG) {
        imgFile <- paste0(geneSetName,"_AUC.png")
        figsMatrix[geneSetName, "AUC"] <- imgFile# paste("<img src=\"", imgFile, "\") height=\"100\" alt=\"",imgFile, "\"></img>", sep = "")
        png(paste0(dirName, imgFile))
      }
      ### Plot
      .auc_plotGradientTsne(tSNE, cellProp=getAUC(cellsAUC)[geneSetName,],
                            title=geneSetName, txt="Gene set activity (AUC)",
                            cex=cex, alphaOn=alphaOn, alphaOff=alphaOff,
                            borderColor=borderColor, offColor=offColor, ...)
      if(asPNG) dev.off()
    }
    
    ######### t-SNE 3: expression #############
    # TF expression
    if("expression" %in% tolower(plots))
    {
      gene <- gsub( "\\s\\(\\d+g)", "",geneSetName)
      gene <- gsub( "_extended", "", gene)
      if(gene %in% rownames(exprMat))
      {
        if(asPNG) {
          imgFile <- paste0(geneSetName,"_expression.png")
          figsMatrix[geneSetName, "expression"] <- imgFile# paste("<img src=\"", imgFile, "\") height=\"100\" alt=\"",imgFile, "\"></img>", sep = "")
          png(paste0(dirName, imgFile))
        }
        ### Plot
        .auc_plotGradientTsne(tSNE, cellProp=exprMat[gene,],
                              colorsForPal = exprCols,
                              title=paste(gene, "expression"), txt="",
                              cex=cex, alphaOn=alphaOn, alphaOff=alphaOff,
                              borderColor=borderColor, offColor=offColor, ...)
        if(asPNG) dev.off()
      }
    }
  }
  if(asPNG) {
    cells_trhAssignment <- c(cells_trhAssignment, figsMatrix=list(figsMatrix))
    if("R2HTML" %in% rownames(installed.packages())) asHTML(figsMatrix, dirName)
  }
  invisible(cells_trhAssignment)
}

asHTML <- function(figsMatrix, imgDir="./")
{
  figsMatrix <- t(apply(figsMatrix, 1, function(x) paste("<img src=\"", imgDir, x, "\") height=\"100\"></img>", sep = "")))
  
  #file.copy("test.css", ".")
  R2HTML::HTML(figsMatrix, file=R2HTML::HTMLInitFile("."))#, CSSFile="test.css")
  R2HTML::HTMLEndFile()
}

# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
dim(exprMatrix)
##################################################

######### Previous steps in the workflow #########
# Step 1.
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=FALSE)

# Step 2.
# (Gene sets: random genes)
geneSets <- list(geneSet1=sample(rownames(exprMatrix), 10),
                 geneSet2=sample(rownames(exprMatrix), 5))
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)
##################################################

############## Step 3: Assign cells ##############

# 1. Plot histograms and obtain some pre-computed thresholds
# (this example is only meant to show the interface/arguments of the function,
# see the vignette for meaningful examples)
set.seed(123)
par(mfrow=c(1,2)) # Plot is divided into one row and two columns
thresholds <- AUCell_exploreThresholds(cells_AUC, plotHist=TRUE)
thresholds$geneSet1$aucThr

# 2. Obtain cells over a given threshold:
names(which(getAUC(cells_AUC)["geneSet1",] > 0.19))

# Alternative 1: assign cells according to the 'automatic' threshold
cells_assignment <- AUCell_exploreThresholds(cells_AUC,
                                             plotHist=FALSE, assignCells=TRUE)
# Cells assigned:
getAssignments(cells_assignment)
# Threshold applied:
getThresholdSelected(cells_assignment)

# Alternative 2: choose a threshold manually and assign cells
newThresholds = getThresholdSelected(cells_assignment)
newThresholds['geneSet1'] = 0.8
newAssignments = AUCell_assignCells(cells_AUC, newThresholds)
getAssignments(newAssignments)

#' @title Get gene set name (excluding number of genes/regions after space)
#' @description Returns the gene set name (i.e. selects the given pattern)
#' @param aucMat AUC matrix
#' @param patterns patterns
#' @param startChr  Character to indicate the start (typically "^")
#' @param endChr Character at the end of the gene set name, i.e. space or "_" after a transcription factor name
#' @return Returns the gene set name (i.e. selects the given pattern)

#' @export
getSetNames <- function(aucMat, patterns, startChr="^", endChr=" |_")
{
  setNames(sapply(patterns, function(x) grep(paste0(startChr,x,endChr), rownames(aucMat), value=T)),
           names(patterns))
}

######
# Fake run of AUCell
set.seed(123)
exprMatrix <- matrix(
  data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
  nrow=20, 
  dimnames=list(paste("Gene", 1:20, sep=""), 
                paste("Cell", 1:500, sep="")))
geneSets <- list(geneSet1=sample(rownames(exprMatrix), 10),
                 geneSet2=sample(rownames(exprMatrix), 5))

cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats = FALSE)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5, nCores=1)
selectedThresholds <- rowMeans(getAUC(cells_AUC))
cellsTsne<- Rtsne::Rtsne(t(exprMatrix),max_iter = 10)$Y
# cellsTsne<- tsne::tsne(t(exprMatrix),max_iter = 10)
rownames(cellsTsne) <- colnames(exprMatrix)
######


par(mfrow=c(2,3))
thrs <- AUCell_plotTSNE(tSNE=cellsTsne, exprMat=NULL,
                        cellsAUC=cells_AUC, thresholds=selectedThresholds, 
                        plots = c("histogram", "binaryAUC", "AUC"))
 


#####
# Color based on the known phenodata:
cellInfo <- data.frame(cellType1=sample(LETTERS[1:3],ncol(exprMatrix), replace=TRUE), 
                       cellType2=sample(letters[5:7],ncol(exprMatrix), replace=TRUE), 
                       nGenes=abs(rnorm(ncol(exprMatrix))), 
                       row.names=colnames(exprMatrix))
colVars <- list(cellType2=setNames(c("skyblue","magenta", "darkorange"),letters[5:7]))
# dev.off()
plotTsne_cellProps(cellsTsne, cellInfo, colVars=colVars)

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @importFrom graphics plot.new
#' @importFrom graphics par
#' @importFrom graphics boxplot
#' @importFrom graphics mtext
#' @importFrom stats quantile
#' @importFrom Matrix colSums
#'
#' @rawNamespace import(data.table, except = shift)
#' @title plotGeneCount
#' @description Plots a histogram and boxplot for the number of genes
#' detected in each cell.
#' @param exprMat Expression matrix (genes as rows, cells as columns)
#' @param plotStats Logical. If true, it plots the histogram, otherwise only calculates the percentages of genes detected.
#' @param verbose Should the function show progress messages? (TRUE / FALSE)
#' @return Quantiles with the number of genes detected by cell (invisible).
#' his result is also printed if verbose=TRUE.
#' @details
#' It is important to check that most cells have at least the number of
#' expressed/detected genes that are going to be used to calculate the AUC
#' (`aucMaxRank` in `calcAUC()`). The histogram provided by
#' `AUCell_buildRankings()` allows to quickly check this distribution.
#' `plotGeneCount(exprMatrix)` allows to obtain only the plot before
#' building the rankings.
#' @seealso See the package vignette for more details: \code{vignette("AUCell")}
#' @examples
#' ### (Fake expression matrix)
#' exprMatrix <- matrix(sample(c(rep(0, 500), sample(1:3, 500, replace=TRUE))),
#'  nrow=20)
#' rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
#' colnames(exprMatrix) <- paste("Sample", 1:50, sep="")
#' ###
#'
#' plotGeneCount(exprMatrix)
#' title(sub="Fake expression matrix")
#'
#' @export

# Used by buildRankings
# Input: matrix or data.table
# If data.table, do not include the "rn" column (rownames)

plotGeneCount <- function(exprMat, plotStats=TRUE, verbose=TRUE)
{
  if(is(exprMat, "dgCMatrix"))
  {
    countByCell <- Matrix::colSums(exprMat>0, na.rm=TRUE) 
  }else{
    countByCell <- colSums(exprMat>0, na.rm=TRUE) 
  }
  
  if(plotStats){
    sampleType <- "cell"
    plot.new()
    par(fig=c(0,1,0.55,1), new=TRUE)
    na <- boxplot(countByCell, ylim=c(0,max(countByCell)), range=0,
                  col="skyblue", cex.axis=.75, horizontal=TRUE, axes=FALSE)
    par(fig=c(0,1,0,.8), new=TRUE)
    na <- hist(countByCell, main="", col="skyblue", xlab="# of genes",
               ylab="# of cells", cex.axis=.75, xlim=c(0,max(countByCell)))
    mtext("# of genes detected by cell", side=3, outer=TRUE, line=-3, cex=2)
  }

  ret <- c(min=min(countByCell), quantile(countByCell, c(.01,.05, .10, .50, 1)))
  if(verbose){
    message("Quantiles for the number of genes detected by cell: \n",
          "(Non-detected genes are shuffled at the end of the ranking. ",
          "Keep it in mind when choosing the threshold for calculating the AUC).")
    print(ret)
  }
  invisible(ret)
}

## AUCell_plot()
##
# Input:
# Output:

test_plotGeneCount <- function()
{
  library(AUCell)
  ##################################################
  # Previous steps
  set.seed(123)
  exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                       nrow=20)
  rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
  colnames(exprMatrix) <- paste("Cell", 1:500, sep="")

  testOutput <- plotGeneCount(exprMatrix, verbose=FALSE)
  ##################################################

  testthat::expect_equal(class(testOutput), "numeric")
  testthat::expect_equal(length(testOutput), 6)
}

test_that("plotGeneCount tests", test_plotGeneCount())

#' @title orderAUC
#' @description Reorder the gene-sets based on AUC similarity 
#' @param auc AUC (as returned by calcAUC)
#' @return gene-set names in the suggested order
#' @importFrom stats as.dist hclust
# @importFrom S4Vectors as.dist
#' @importFrom stats cor
#' @examples 
#' # cellsAUC <- cellsAUC[orderAUC(cellsAUC),]
#' @export
orderAUC <- function(auc){
  variableGs <- names(which(apply(getAUC(auc), 1, sd) > 0))
  gsDist <-as.dist(1-cor(t(getAUC(auc)[variableGs,]), method="spear"))
  gsClust <- hclust(gsDist, method="ward.D2")
  gsClusters <- setNames(dynamicTreeCut::cutreeDynamic(gsClust, distM=as.matrix(gsDist), verbose = FALSE), gsClust$labels)
  gsOrder <- gsClust$labels[gsClust$order]
  gsOrder <- gsOrder[order(gsClusters[gsOrder], decreasing = TRUE)]
  return(gsOrder)
}

# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
##################################################

cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=TRUE)
cells_rankings

#' @title plotEmb_rgb
#' @description Colors the embeddings (t-SNE/Umap) based on the activity of 3 (groups of) geneSets
#' @param aucMat AUC matrix (continuous or binary)
#' @param embedding AUC matrix (continuous or binary)
#' @param geneSetsByCol Gene sets to plot
#' @param aucType "AUC" or "Binary"
#' @param aucMaxContrast To increase the AUC contrast decrease the value.
#' @param offColor Color por the cells completelly off. To deactivate (color as black), set to NULL.
#' @param showPlot Whether to plot the coloured embeddings.
#' @param showLegend Whether to plot add a legend to the plot.
#' @param ... Other arguments to pass to the \code{plot} function.
#' @return The cell colors (invisible)
#' @importFrom grDevices rgb
#' @examples 
# par(mfrow=c(1,2))
# 
# setNames <- c("Dlx1", "Sox8")
# cellCol <- plotEmb_rgb(mat2col, emb, setNames, aucType="AUC", aucMaxContrast=0.6)
# text(-5,-23, attr(cellCol,"red"), col="red", cex=.7)
# text(-10,-18, attr(cellCol,"green"), col="green", cex=.7)
# 
# setNames <- list(red=c("Dlx1","Dlx5"),
#                      green=c("Neurod1"),
#                      blue=c("Sox8"))
# cellCol <- plotEmb_rgb(mat2col, emb, setNames, aucType="Binary")


#' @export
plotEmb_rgb <- function(aucMat, embedding, geneSetsByCol, 
                        aucType="AUC", 
                        aucMaxContrast=0.8, offColor="#c0c0c030", 
                        showPlot=TRUE, showLegend=TRUE, ...)
{
  # Check format
  if(length(geneSetsByCol)>3) stop("To plot more than three regulons, group them by color.")
  if(any(!names(geneSetsByCol) %in% c("red","green", "blue"))) 
    stop('If a list, the names of geneSetsByCol should be "red","green", and/or"blue".')
  if(aucMaxContrast<=0 | aucMaxContrast>1) stop("aucMaxContrast should be between 0 and 1")
  if(!tolower(aucType) %in% c("binary","bin", "auc","continuous","cont")) stop("aucType should be binary or auc/continuous")
  
  if(is.null(names(geneSetsByCol)) && length(geneSetsByCol)<=3) {
    names(geneSetsByCol) <- c("red","green", "blue")[seq_along(geneSetsByCol)]
    geneSetsByCol <- as.list(geneSetsByCol)
  }
  
  geneSetsByCol <- geneSetsByCol[lengths(geneSetsByCol)>0]
  
  # Average of binary...
  if(tolower(aucType) %in% c("binary","bin"))
    cellColChan <- sapply(geneSetsByCol, function(modsCol) apply(getAUC(aucMat)[modsCol,, drop=FALSE], 2, mean))
  # Color if all modules are "on"
  # cellColChan <- sapply(geneSetsByCol, function(modsCol) apply(aucMat[modsCol,, drop=FALSE], 2, function(x) as.numeric(sum(x)==length(x))))
  
  # AUC
  if(tolower(aucType) %in% c("auc","continuous","cont")) {
    cellColChan <- sapply(geneSetsByCol, function(regCol) {
      aucAvg <- base::colMeans(getAUC(aucMat[regCol,, drop=FALSE]))
      setNames(sapply(as.numeric(aucAvg/(max(aucAvg)*aucMaxContrast)), min, 1), names(aucAvg))
    })
  }
  
  # Apply color
  missingCol <- setdiff(c("red","green", "blue"), colnames(cellColChan))
  if(length(missingCol)>0)
    cellColChan <- cbind(cellColChan, matrix(rep(0, nrow(cellColChan)*length(missingCol)),ncol=length(missingCol), dimnames=list(NULL,missingCol)))
  cellCol <- apply(cellColChan, 1, function(x) rgb(x["red"], x["green"], x["blue"], alpha=.8))
  if(!is.null(offColor)) cellCol[which(cellCol=="#000000CC")] <- offColor # mostly for binary
  names(cellCol) <- colnames(aucMat)
  
  if(aucType=="binary") attr(cellCol,"Description") <- "Color: average of BINARY regulon activity"
  if(aucType=="auc") attr(cellCol,"Description") <- "Color: average of regulon activity (AUC)"
  attr(cellCol, "red") <- paste0(geneSetsByCol$red, collapse=", ")
  attr(cellCol, "green") <- paste0(geneSetsByCol$green, collapse=", ")
  attr(cellCol, "blue") <- paste0(geneSetsByCol$blue, collapse=", ")
  
  if(showPlot) 
  {
    plot(embedding, col=cellCol[rownames(embedding)], pch=16, 
         sub=attr(cellCol, "Description"), axes=FALSE, ...)
    
    if(showLegend)
    {
      cellColChan[which(cellColChan < (aucMaxContrast/2), arr.ind = T)] <- 0
      cellColChan <- cellColChan[which(apply(cellColChan, 1, function(x) any(x>0))),]
      cellLabels <- setNames(colnames(cellColChan)[apply(cellColChan, 1, function(x) which.max(x))], rownames(cellColChan))
      labsCoords <- t(sapply(split(data.frame(embedding), as.character(cellLabels[rownames(embedding)])), colMeans));
      
      geneSetsByCol[rownames(labsCoords)] <- sapply(geneSetsByCol[rownames(labsCoords)], paste, collapse=", ")
      for(i in rownames(labsCoords)) text(mean(labsCoords[i,1]), mean(labsCoords[i,2]), geneSetsByCol[i], cex=1, col="black")
    }
  }
  invisible(cellCol)
}

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)

#' @importFrom stats setNames
#' @importFrom methods new
#'
#' @title Update AUCell results
#' @description Updates the AUC scores provided by AUCell from a previous version.
#' @param oldAucObject Object to update
#' @param objectType Either "AUC" or "ranking" indicating the object type
#' @return Updated version of the object as \code{\link{aucellResults}}.
#' @examples
#' oldAuc <- matrix(data=1:2000, nrow=50, ncol=40)
#' updateAucellResults(oldAuc)
#' @export
#'
updateAucellResults <- function(oldAucObject, objectType="AUC")
{
  objectType <- tolower(objectType)
  if(!objectType %in% c("auc", "ranking")) stop("'objectType' should be either 'AUC' or 'ranking'.")

  newAucObject <- NULL
  if(methods::is(oldAucObject,"matrixWrapper")) 
  {
    aucMatrix <- oldAucObject@matrix
    #library(SummarizedExperiment)
    if(objectType== "auc") newAucObject <- new("aucellResults", SummarizedExperiment::SummarizedExperiment(assays=list(AUC=aucMatrix)))
    if(objectType== "ranking") newAucObject <- new("aucellResults", SummarizedExperiment::SummarizedExperiment(assays=list(ranking=aucMatrix)))
  }

  if(methods::is(oldAucObject,"matrix"))
  {
    aucMatrix <- oldAucObject
    # library(SummarizedExperiment)
    if(objectType== "auc") newAucObject <- new("aucellResults", SummarizedExperiment::SummarizedExperiment(assays=list(AUC=aucMatrix)))
    if(objectType== "ranking") newAucObject <- new("aucellResults", SummarizedExperiment::SummarizedExperiment(assays=list(ranking=aucMatrix)))
  }

  return(newAucObject)
}

# .auc_plotGradientTsne
# .auc_plotBinaryTsne
# .cellProps_plotTsne  # For APP, only one prop
#     plotTsne_cellProps: For SCENIC, iterator: plots all properties

########################################################################
# txt <- paste0("Cells with AUC > ", signif(gsTrheshold, 2))
.auc_plotBinaryTsne <- function(tSNE, selectedCells,  
                                title="", txt="Coloured cells pass the threshold",
                                cex=1,
                                alphaOn=1, alphaOff=0.2,
                                onColor="dodgerblue4", offColor="lightgray", 
                                borderColor=adjustcolor("lightgray", alpha.f=.1),
                                ...)  
{
  pointBg <-  setNames(rep(adjustcolor(offColor, alpha.f=alphaOff), nrow(tSNE)), rownames(tSNE))
  pointBg[selectedCells] <- adjustcolor(onColor , alpha.f=alphaOn) # "royalblue4"
  pointBorder <- setNames(rep(borderColor, nrow(tSNE)), rownames(tSNE))
  
  ### Plot
  plot(tSNE, pch=21, cex=cex,
       col=pointBorder, bg=pointBg,
       main=title, xlab=txt,
       axes=FALSE, ylab="", ...)
  box(which = "plot", col="grey")
}

.auc_plotGradientTsne <- function(tSNE, cellProp,
                                  colorsForPal=c("mistyrose", "red"),
                                  title="", txt="Regulon activity (AUC)", 
                                  alphaOn=1, alphaOff=0.2,
                                  offColor="lightgray", 
                                  borderColor=adjustcolor("darkgrey", alpha.f=.3),
                                  cex=1,
                                  ...)
{
  # Setup palette
  nBreaks <- 5
  colorPal <- grDevices::colorRampPalette(colorsForPal)(nBreaks)
  colorPal <- adjustcolor(colorPal, alpha.f=alphaOn)
  
  # Assign cell color
  cellColor <- setNames(rep("black", nrow(tSNE)), rownames(tSNE))
  pointBorder <- setNames(rep(borderColor, nrow(tSNE)), rownames(tSNE))
  if (sum(cellProp) > 0)
  {
    # On
    cellColor[names(cellProp)] <- colorPal[as.numeric(cut(cellProp, breaks=nBreaks, right=FALSE,include.lowest=TRUE))]
    # Off
    lowLim <- 0
    tryCatch({
      lowLim <- as.numeric(gsub("]", "", strsplit(levels(cut(cellProp, breaks=100))[1], ",")[[1]][2]))
    },error = function(e) {
      save(cellProp, file="error_cellProp.RData")
      message("There was an error trying to plot the t-SNE. Please report it in https://github.com/aertslab/AUCell (file for debugging: error_cellProp.RData). ",
              "\nError message: ", e$message)
    })
  } else
  {
    cellColor[names(cellProp)] <- c(adjustcolor(offColor, alpha.f=alphaOff), length(cellProp))
  }
  
  # Plot
  pointBg <- cellColor
  plot(tSNE, pch=21, cex=cex,
       col=pointBorder, bg=pointBg,
       main=title, xlab=txt,
       axes=FALSE, ylab="", ...)
  box(which = "plot", col="grey")
}


########################################################################
####                    CELL properties                            #####
#' @title plotTsne_cellProps
#' @description Plots the t-SNE coloured based on the known the cell properties
#' @param tSNE t-SNE coordinates (e.g. \code{tSNE$Y})
#' @param cellInfo Dataframe with cell phenodata
#' @param colVars Colors for the cell properties (optional)
#' @param cex Scaling factor for the dots in the scatterplot
#' @param sub Subtitle (e.g. tSNE type)
#' @param gradientCols Gradient colors for numerical variables
#' @param showLegend Whether to show the legend
#' @return Plots the t-SNE
#' @example inst/examples/example_AUCell_plotTSNE.R
#' @export
plotTsne_cellProps <- function(tSNE, cellInfo, colVars=NULL,
                               cex=1, sub="", 
                               gradientCols=c("yellow", "orange","red"),
                               showLegend=TRUE)
{
  if(!is.matrix(tSNE)) stop("tSNE should be a matrix.")
  
  # If it is null, plot all cells black
  if(is.null(cellInfo)) {
    cellInfo <- data.frame(row.names=rownames(tSNE), tSNE=rep("xx",nrow(tSNE)))
    showLegend <- FALSE
  }
  
  cellInfo <- data.frame(cellInfo)[rownames(tSNE),,drop=F]
  for(varName in colnames(cellInfo))
  {
    .cellProps_plotTsne(tSNE, cellInfo, varName, colVars=colVars, cex=cex,
                        sub=sub, gradientCols=gradientCols, showLegend=showLegend)
  }
}


.cellProps_plotTsne <- function(tSNE, cellInfo, varName=NULL, colVars=NULL, cex=1,
                                sub="", gradientCols=c("yellow", "orange","red"),
                                showLegend=TRUE)
{
  if(!is.null(varName))
  {
    if(!methods::is(cellInfo[,varName],"numeric"))
    {
      if(is.null(colVars[[varName]])) {
        varLevels <- as.character(unique(cellInfo[,varName]))
        colVars[varName] <- list(setNames(rep("black", length(varLevels)), varLevels))
        if(length(colVars[[varName]])>1) colVars[[varName]] <- setNames(rainbow(length(unique(cellInfo[,varName]))), unique(cellInfo[,varName]))
      } 
      cellColor <- setNames(rep("#30303010", nrow(tSNE)), rownames(tSNE))
      thisProp <- setNames(as.character(cellInfo[, varName]), rownames(cellInfo))
      thisProp <- thisProp[which(!is.na(thisProp))]
      propLevels <- levels(factor(thisProp))
      cellColor[names(thisProp)] <- colVars[[varName]][thisProp]
    }else
    {
      # if(is.null(colVars[[varName]])) {
      #   colVars[[varName]] <- setNames(rainbow(length(unique(cellInfo[,varName]))), unique(cellInfo[,varName]))
      # } 
      colorPal <- grDevices::colorRampPalette(gradientCols)
      cellColor <- setNames(adjustcolor(colorPal(10), alpha.f=.8)[as.numeric(cut(cellInfo[,varName],breaks=10, right=FALSE,include.lowest=TRUE))], rownames(cellInfo))
    }
    
    colsLegend <- colVars[[varName]]
    if(methods::is(cellInfo[,varName],"numeric"))
      colsLegend <- setNames(gradientCols[c(length(gradientCols),1)], signif(c(max(cellInfo[,varName]), min(cellInfo[,varName])),2))
    
    plot(tSNE, pch=16, cex=cex,
         col=cellColor[rownames(tSNE)],
         main=varName, 
         sub=sub,
         axes=FALSE, xlab="", ylab="")
    if(showLegend) legend(min(tSNE[,1]), max(tSNE[,2]), names(colsLegend), col=colsLegend,
                          bg=NULL,border=NULL, box.lwd="none", bty = "n", cex=.8, pch=16)
    box(which = "plot", col="grey")
  }
}

#' @title GeneSet methods
#' @description Functions to manipulate GeneSet and GeneSetCollection objects
#' (from package GSEABase)
#' @import GSEABase
#' @param geneSet One gene-set (\code{\link{GeneSet}})
#' @param geneSets Gene-set collection
#' (\code{\link{GeneSetCollection}})
#' @param geneNames Gene names (for subset)
#' @param newNames New names (to assign to the gene sets)
#' @return
#' - **nGenes()**: provides the number of genes in the gene-set,
#' or each of the gene-sets in a collection
#'
#' - **subsetGeneSets()**: Subsets each of the gene-sets in a collection
#' to contain only the genes inthe given list. Equivalent to intersect(),
#' but keeping the original gene-set name.
#'
#' - **setGeneSetNames()**: Modifies the name of each gene-set in a collection
#' @docType methods
#' @rdname GeneSet-methods
#'
#' @example inst/examples/example_geneSet_methods.R
#' @export
setGeneric("nGenes", signature="geneSet",
           function(geneSet)
           {
             standardGeneric("nGenes")
           })

#' @rdname GeneSet-methods
#' @aliases nGenes,GeneSet-method
setMethod("nGenes", "GeneSet",
  function(geneSet)
  {
    length(GSEABase::geneIds(geneSet))
  })

#' @rdname GeneSet-methods
#' @aliases nGenes,GeneSetCollection-method
setMethod("nGenes", "GeneSetCollection",
  function(geneSet)
  {
    setNames(sapply(geneSet, nGenes), names(geneSet))
  })

# equivalent to intersect, but keeping original name
#' @rdname GeneSet-methods
#' @export
setGeneric("subsetGeneSets",
  function(geneSets, geneNames)
  {
    standardGeneric("subsetGeneSets")
  })

#' @rdname GeneSet-methods
#' @aliases subsetGeneSets,GeneSetCollection-method
setMethod("subsetGeneSets", signature="GeneSetCollection",
  function(geneSets, geneNames)
  {
    GSEABase::GeneSetCollection(lapply(geneSets, function(x) {
      y <- x & geneNames
      GSEABase::setName(y) <- GSEABase::setName(x)
      y
    }))
  })

#' @rdname GeneSet-methods
#' @export
setGeneric("setGeneSetNames",
  function(geneSets, newNames)
  {
    standardGeneric("setGeneSetNames")
  })


#' @rdname GeneSet-methods
#' @aliases setGeneSetNames,GeneSetCollection-method
setMethod("setGeneSetNames", signature="GeneSetCollection",
  function(geneSets, newNames)
  {
    if(length(geneSets) != length(newNames))
      stop("The number of gene sets and new names do not match.")

    geneSets <- unlist(geneSets)
    for(i in seq_len(length(newNames)))
    {
      GSEABase::setName(geneSets[[i]]) <- newNames[i]
    }
    GSEABase::GeneSetCollection(geneSets)
  })

#' @title Wrapper to the matrix that stores the AUC or the cell rankings.
#' @aliases getAUC getRanking show cbind
#' @description
#' This class extends SummarizedExperiment to contain the AUC matrix and cell
#' rankings (as 'assays').
#'
#' The results are stored in the assays slot, but they can be accessed through
#' the regular methods (i.e. nrow, rownames... )
#'
#' Types:
#'
#'  - "AUC": The assays contains the AUC for the gene-sets (or region-sets)
#'  & cells.
#'
#'  - "ranking": The assays contains the gene rankings for each cell.
#'
#' @param object Results from \code{AUCell_buildRanking}
#' @param deparse.level (Only for cbind) 
#' @param ... (Only for cbind) 
#' 
#' or \code{AUCell_calcAUC}.
#' @return
#' \itemize{
#' \item show: Prints a summary of the object
#' \item getAUC: Returns the matrix containing the AUC
#' \item getRanking: Returns the matrix containing the rankings
#' \item cbind: Combines objects by columns (cbind on \code{assays}); other other slots are conserved from the first object provided as argument.
#' Both, ranking and AUC are calculated by column (cell or sample). Therefore, it is fine to merge objects as long as they come from equivalent datasets (and keep same genes/genesets, etc...)
#' }
#' @method show aucellResults
#' @method getAUC aucellResults
#' @method getRanking aucellResults
#' @example inst/examples/example_aucellResults_class.R
#' @rawNamespace import(data.table, except = shift)
#' @importClassesFrom SummarizedExperiment SummarizedExperiment
#' @importMethodsFrom SummarizedExperiment assay assays assayNames
#' @importFrom methods is
#' @importFrom utils head
#' @rdname aucellResults-class
#' @export aucellResults
aucellResults <- setClass("aucellResults",
                          contains="SummarizedExperiment",
                          representation=representation(
                            nGenesDetected = "numeric"
                          )
)
#' @importFrom R.utils capitalize
#' @rdname aucellResults-class
#' @aliases show,aucellResults-method
setMethod("show",
          signature="aucellResults",
          definition = function(object) {
            message <- paste(R.utils::capitalize(assayNames(object)), " for ",
                             nrow(object)," ", names(dimnames(assay(object)))[1],
                             " (rows) and ",
                             ncol(object)," ", names(dimnames(assay(object)))[2],
                             " (columns).\n", sep="")
            
            if(assayNames(object) == "AUC")
              message <- paste(message,
                               "\nTop-left corner of the AUC matrix:\n", sep="")
            if(assayNames(object) == "ranking")
              message <- paste(message,
                               "\nTop-left corner of the ranking:\n", sep="")
            
            cat(message)
            show(head(assay(object)[,seq_len(min(5, ncol(object))),drop=FALSE]))
            
            if(is.numeric(object@nGenesDetected) &&
               (length(object@nGenesDetected)>0)) {
              cat("\nQuantiles for the number of genes detected by cell:\n")
              show(object@nGenesDetected)
            }
          }
)
##### Access the matrix:
#' @name getAUC
#' @rdname aucellResults-class
# Export generic, for RcisTarget
#' @export getAUC 
setGeneric(name="getAUC",
           def=function(object) standardGeneric("getAUC"))

#' @rdname aucellResults-class
#' @aliases getAUC,aucellResults-method
#' @exportMethod getAUC
setMethod("getAUC",
          signature="aucellResults",
          definition = function(object) {
            if("AUC" %in% assayNames(object)) {
              SummarizedExperiment::assays(object)[["AUC"]]
            }else{
              stop("This object does not contain an AUC matrix.")
            }
          }
)

##### Access the rankings:
# setGeneric
# @method test data.frame
#' @name getRanking
#' @rdname aucellResults-class
# Export generic, for RcisTarget
#' @export getRanking 
setGeneric(name="getRanking",
           def=function(object) standardGeneric("getRanking"))

#' @rdname aucellResults-class
#' @aliases getRanking,aucellResults-method
#' @exportMethod getRanking
setMethod("getRanking",
          signature="aucellResults",
          definition = function(object) {
            if("ranking" %in% assayNames(object)) {
              SummarizedExperiment::assays(object)[["ranking"]]
            }else{
              stop("This object does not contain a ranking.")
            }
          }
)

##### Combine objects (by colums):
#' @name cbind
#' @rdname aucellResults-class
#' @aliases cbind,aucellResults-method
#' @importFrom BiocGenerics cbind
# replaces slots not exported...
# @import S4Vectors
#' @export 
setMethod("cbind", "aucellResults", function(..., deparse.level=1) {
  args <- list(...)
  objectType <- unique(sapply(args, function(x) names(SummarizedExperiment::assays(x))))
  if(length(objectType)>1) stop("All objects should be of the same type (e.g. ranking OR AUC).")
  dimNames <- apply(sapply(args, function(x) names(dimnames(SummarizedExperiment::assay(x)))), 1, function(x) unique(x)) # vapply instead...
  if(length(dimNames)!=2)  stop("Dimnames do not match.")
  
  allAssays <- lapply(args, SummarizedExperiment::assay, withDimnames=TRUE)
  if(length(unique(sapply(allAssays, nrow)))>1)
    stop("Number of rows (",dimNames[1],") do not match.")
  if(!all(apply(rbind(sapply(allAssays, rownames)), 1, function(x) length(unique(x)))==1))
    stop("Rownames (",dimNames[1],") do not match.")
  if(any(table(unlist(sapply(allAssays, colnames)))>1))
    stop("Some column IDs (",dimNames[2],") are duplicated.")
  
  allAssays <- do.call(cbind, allAssays)
  names(dimnames(allAssays)) <- dimNames
  
  # old.validity <- S4Vectors:::disableValidity()
  # S4Vectors:::disableValidity(TRUE)
  # on.exit(S4Vectors:::disableValidity(old.validity))
  
  #### Slots used:
  # new("aucellResults",
  #     SummarizedExperiment::SummarizedExperiment(assays=list(ranking=exprMat)),
  #     nGenesDetected=nGenesDetected)
  # new("aucellResults",
  #     SummarizedExperiment::SummarizedExperiment(assays=list(AUC=aucMatrix)))
  ####
  
  ## Error: list()
  # out <- callNextMethod()
  # BiocGenerics:::replaceSlots(out,
  #                             assays=setNames(list(allAssays),  objectType),
  #                             check=FALSE)
  
  
  new("aucellResults",
      SummarizedExperiment::SummarizedExperiment(
        assays=setNames(list(allAssays),  objectType)
      ),
      nGenesDetected=args[[1]]@nGenesDetected) # (nGenesDetected is taken from first object)  
})

##### Combine objects (by rows):
#' @name rbind
#' @rdname aucellResults-class
#' @aliases rbind,aucellResults-method
#' @importFrom BiocGenerics rbind
# replaceslots not exported...
# @import S4Vectors
#' @export 
setMethod("rbind", "aucellResults", function(..., deparse.level=1) {
  args <- list(...)
  objectType <- unique(sapply(args, function(x) names(SummarizedExperiment::assays(x))))
  if(length(objectType)>1) stop("All objects should be of the same type (e.g. ranking OR AUC).")
  dimNames <- apply(sapply(args, function(x) names(dimnames(SummarizedExperiment::assay(x)))), 1, function(x) unique(x)) # vapply instead...
  if(length(dimNames)!=2)  stop("Dimnames do not match.")
  
  allAssays <- lapply(args, SummarizedExperiment::assay, withDimnames=TRUE)
  if(length(unique(sapply(allAssays, ncol)))>1)
    stop("Number of columns (",dimNames[2],") do not match.")
  if(!all(apply(rbind(sapply(allAssays, colnames)), 1, function(x) length(unique(x)))==1))
    stop("Rownames (",dimNames[2],") do not match.")
  if(any(table(unlist(sapply(allAssays, rownames)))>1))
    stop("Some row IDs (",dimNames[1],") are duplicated.")
  
  allAssays <- do.call(rbind, allAssays)
  names(dimnames(allAssays)) <- dimNames
  
  # old.validity <- S4Vectors:::disableValidity()
  # S4Vectors:::disableValidity(TRUE)
  # on.exit(S4Vectors:::disableValidity(old.validity))
  
  new("aucellResults",
      SummarizedExperiment::SummarizedExperiment(
        assays=setNames(list(allAssays),  objectType)
      ),
      nGenesDetected=args[[1]]@nGenesDetected) # (nGenesDetected is taken from first object)  
})

library(GSEABase)
genes_1 <- GeneSet(paste("Gene", 1:20, sep=""), setName="geneSet1")
genes_2 <- GeneSet(paste("Gene", 18:22, sep=""), setName="geneSet2")
geneSets <- GeneSetCollection(genes_1, genes_2)

nGenes(genes_1)
nGenes(geneSets)

subsetGeneSets(geneSets, paste("Gene", 15:20, sep=""))

geneSets_newNames <- setGeneSetNames(geneSets, c("one", "two"))
names(geneSets_newNames)

# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
##################################################

######### Previous step in the workflow ##########
# Step 1.
cells_rankings <- AUCell_buildRankings(exprMatrix)
##################################################

############## Step 2: Calculate AUC #############

# In this example we use two gene sets: 10 and 5 random genes
# (see other formatting examples at the end)
fewGenes <- sample(rownames(exprMatrix), 10)
otherGenes <- sample(rownames(exprMatrix), 5)

geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
geneSets

# Calculate AUC with the rankings from Step 1.
# To be able to run this fake example (which contain only 20 genes),
# we use aucMaxRank=5 (top 25% of the genes in the ranking)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5, nCores=1)

# Format of the output:
cells_AUC

# To subset & access the AUC slot (as matrix):
cells_AUC[1:2,]
cells_AUC[,3:4]
getAUC(cells_AUC)[,1:5]


# These methods are also available:
dim(cells_AUC)
nrow(cells_AUC)
ncol(cells_AUC)
colnames(cells_AUC)[1:4]
rownames(cells_AUC)

#########################################################
# Alternatives for the input of gene sets:

# a) Character vector (i.e. only one gene-set)
# It will take the default name 'geneSet'
fewGenes
test <- AUCell_calcAUC(fewGenes, cells_rankings, aucMaxRank=5)

# b) List
geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
geneSets
test <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)

# c) GeneSet object (from GSEABase)
library(GSEABase)
geneSetOne <- GeneSet(fewGenes, setName="geneSetOne")
geneSetOne
test <- AUCell_calcAUC(geneSetOne, cells_rankings, aucMaxRank=5)


# d) GeneSetCollection object (from GSEABase)
geneSetTwo <- GeneSet(otherGenes, setName="geneSetTwo")
geneSets <- GeneSetCollection(geneSetOne, geneSetTwo)
geneSets
test <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)

binarizeAUC <- function(auc, thresholds)
{
  thresholds <- getThresholdSelected(thresholds)
  thresholds <- thresholds[intersect(names(thresholds), rownames(auc))]
  regulonsCells <- setNames(lapply(names(thresholds), 
                                   function(x) {
                                     trh <- thresholds[x]
                                     names(which(getAUC(auc)[x,]>trh))
                                   }),names(thresholds))
  
  ### Convert to matrix (regulons with zero assigned cells are lost)
  regulonActivity <- reshape2::melt(regulonsCells)
  binaryRegulonActivity <- t(table(regulonActivity[,1], regulonActivity[,2]))
  class(binaryRegulonActivity) <- "matrix"  
  
  return(binaryRegulonActivity)
}

#' @rdname AUCell_exploreThresholds
#' @aliases getThresholdSelected
#' @export
getThresholdSelected <- function(aucellThresholds){
  sapply(aucellThresholds, function(x) {
    ret <- x # already only one threshold
    if(length(x) > 1) {
      #otherwise do not modify, it might already be the selected
      if(("aucThr" %in% names(x)) & ("selected" %in% names(x$aucThr)))  
        ret <- unname(x$aucThr$selected)
    }
    return(ret)
  })
}

#' @rdname AUCell_exploreThresholds
#' @aliases getThresholdSelected
#' @export
getAssignments <- function(aucellThresholds){
  lapply(aucellThresholds, function(x) x$assignment)
}

# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.


############# Fake run of AUCell #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
dim(exprMatrix)

# Running AUCell
cells_rankings <- AUCell_buildRankings(exprMatrix)
fewGenes <- sample(rownames(exprMatrix), 10)
otherGenes <- sample(rownames(exprMatrix), 5)
geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5, nCores=1)
##############################################

#Exploring the output:
cells_AUC

class(cells_AUC)

# Extracting the AUC matrix:
getAUC(cells_AUC)[,1:5]

# Subsetting and regular manipulation methods are also available:
cells_AUC[1:2,]
cells_AUC[,3:4]

dim(cells_AUC)
nrow(cells_AUC)
ncol(cells_AUC)
colnames(cells_AUC)
rownames(cells_AUC)

### Merging 2 objects (ranking or AUC):
sample1 <- cells_AUC[,10:20]
sample2 <- cells_AUC[,100:140]
cbind(sample1, sample2)

# Help files will be automatically generated from the coments starting with #'
# (https://cran.r-project.org/web/packages/roxygen2/vignettes/rd.html)
#
#' @title AUCell_assignCells
#' @description Assigns whether the gene sets are considered "active" on each cell
#' based on the given thresholds
#' @param cellsAUC AUC object returned by \code{\link{AUCell_calcAUC}}.
#' @param thresholds Thresholds selected for each geneset (named vector).
#' @param nCores Number of cores to use for computation.
#' @return List with the following elements for each gene-set:
#' \itemize{
#' \item 'aucThr' threshold value, in the same format as AUCell_exploreThresholds()
#' \item 'assignment' List of cells that pass the selected AUC threshold
#' }
#' @seealso Previous step in the workflow: \code{\link{AUCell_calcAUC}} 
#' and optionally \code{\link{AUCell_exploreThresholds}} 
#'
#' See the package vignette for examples and more details:
#' \code{vignette("AUCell")}
#' @example inst/examples/example_AUCell_exploreThresholds.R
#' 
# Function copied from AUCell_exploreThresholds and removed the assingment
# (not the best practice: in the future better use common code)
#' @export
AUCell_assignCells <- function(cellsAUC, thresholds, nCores=1)
{
  #####  Extract AUC matrix
  aucMatrix <- NULL
  if(methods::is(cellsAUC,"aucellResults")){
    aucMatrix <- getAUC(cellsAUC)
  }
  
  if(methods::is(cellsAUC,"matrixWrapper"))
  {
    stop('The AUC was calculated with a previous AUCell version. \n",
         "Please update them with updateAucellResults(..., objectType="AUC")')
  }
  
  if(is.matrix(cellsAUC)) {
    aucMatrix <- cellsAUC
  }
  if(!is.matrix(aucMatrix)) stop("cellsAUC should contain the AUC values.")
  
  rowSumAUC <- rowSums(aucMatrix)
  if(any(rowSumAUC==0)) warning("Skipping genesets with all AUC 0: ", 
                                paste(names(rowSumAUC)[which(rowSumAUC==0)], collapse=", "), 
                                immediate. = TRUE)
  aucMatrix <- aucMatrix[rowSumAUC>0,,drop=FALSE]
  #########
  
  if(nCores==1)
  {
    gSetName <- NULL
    assigment <- lapply(rownames(aucMatrix), function(gSetName)
    {
      aucThr <- thresholds[gSetName]
      assignedCells <- NULL
      if(!is.null(aucThr)){
        auc <- aucMatrix[gSetName,]
        assignedCells <- names(auc)[which(auc>aucThr)]
      }

      list(aucThr=list(selected=aucThr), assignment=assignedCells)

    })
    names(assigment) <- rownames(aucMatrix)
    
  }else
  {
    # Run each geneSet in parallel
    doRNG::registerDoRNG(nCores)
    # if(verbose)
    message("Using ", foreach::getDoParWorkers(), " cores.")

    "%dopar%"<- foreach::"%dopar%"
    suppressPackageStartupMessages(assigment <-
                                     doRNG::"%dorng%"(foreach::foreach(gSetName=rownames(aucMatrix)),
                                                      {
                                                        aucThr <- thresholds[gSetName]
                                                        assignedCells <- NULL
                                                        if(!is.null(aucThr)){
                                                          auc <- aucMatrix[gSetName,]
                                                          assignedCells <- names(auc)[which(auc>aucThr$selected)]
                                                        }
                                                        tmp <- list(aucThr=list(selected=aucThr), assignment=assignedCells)
                                                        return(setNames(list(tmp), gSetName))
                                                      }))
    attr(assigment, "rng") <- NULL
    assigment <- unlist(assigment, recursive = FALSE)[rownames(aucMatrix)]
  }

  return(assigment)
}

## AUCell_buildRankings()
##
# Input:
# Output:

test_AUCell_buildRankings <- function()
{
  library(AUCell)
  ##################################################
  ### Fake dataset
  set.seed(123)
  exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                       nrow=20)
  rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
  colnames(exprMatrix) <- paste("Cell", 1:500, sep="")
  ##################################################

  cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=TRUE, verbose=FALSE)

  .check_AUCell_buildRankings_output(cells_rankings)

  ### Other input classes:
  eset <- Biobase::ExpressionSet(assayData=exprMatrix)
  rEset <- AUCell_buildRankings(eset, plotStats=FALSE)
  testthat::expect_equal(class(rEset)[1], "aucellResults")

  sexp <- SummarizedExperiment::SummarizedExperiment(assays=list(counts=exprMatrix))
  rSexp <- AUCell_buildRankings(sexp, plotStats=FALSE)
  testthat::expect_equal(class(rSexp)[1], "aucellResults")

  sparseMat <- as(exprMatrix, "dgCMatrix")
  rSparse <- AUCell_buildRankings(sparseMat, plotStats=FALSE, splitByBlocks=TRUE)
  testthat::expect_equal(class(rSparse)[1], "aucellResults")
}

.check_AUCell_buildRankings_output <- function(cells_rankings)
{
  testthat::expect_equal(ncol(cells_rankings), 500)
  testthat::expect_equal(nrow(cells_rankings), 20)
  
  testthat::expect_equal(getRanking(cells_rankings)['Gene13','Cell2'], 1)
  

  testthat::expect_equal(class(cells_rankings)[1], "aucellResults")
  testthat::expect_equal(SummarizedExperiment::assayNames(cells_rankings)[1], "ranking")
}


test_that("AUCell_buildRankings tests", test_AUCell_buildRankings())

## AUCell_run()
##
# Input:
# Output:

test_AUCell_run <- function()
{
  library(AUCell)
  ##################################################
  # Data
  set.seed(123)
  exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                       nrow=20)
  rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
  colnames(exprMatrix) <- paste("Cell", 1:500, sep="")
  ##################################################
  
  ### Test input: Geneset
  # a) Character vector (i.e. only one gene-set)
  fewGenes <- sample(rownames(exprMatrix), 10)
  cellsAUC <- suppressWarnings(AUCell_run(exprMatrix, fewGenes, aucMaxRank=5))

  testthat::expect_equal(nrow(cellsAUC), 1)
  testthat::expect_equal(ncol(cellsAUC), 500)

  # b) List
  otherGenes <- sample(rownames(exprMatrix), 5)
  geneSets <- list(geneSet1=fewGenes,
                   geneSet2=otherGenes)
  cellsAUC <- suppressWarnings(AUCell_run(exprMatrix, geneSets, aucMaxRank=5))

  testthat::expect_equal(nrow(cellsAUC), 2)
  testthat::expect_equal(ncol(cellsAUC), 500)

  # c) GeneSet object (from GSEABase)
  geneSetOne <- GSEABase::GeneSet(fewGenes, setName="geneSetOne")
  cellsAUC <- suppressWarnings(AUCell_run(exprMatrix, geneSetOne, aucMaxRank=5))

  testthat::expect_equal(nrow(cellsAUC), 1)
  testthat::expect_equal(ncol(cellsAUC), 500)

  # d) GeneSetCollection object (from GSEABase)
  geneSetTwo <- GSEABase::GeneSet(otherGenes, setName="geneSetTwo")
  geneSets <- GSEABase::GeneSetCollection(geneSetOne, geneSetTwo)
  set.seed(123)
  cellsAUC <- suppressWarnings(AUCell_run(exprMatrix, geneSets, aucMaxRank=5))

  testthat::expect_equal(nrow(cellsAUC), 2)
  testthat::expect_equal(ncol(cellsAUC), 500)

  testthat::expect_equal(class(cellsAUC)[1], "aucellResults")
  testthat::expect_equal(SummarizedExperiment::assayNames(cellsAUC)[1], "AUC")
  
  ### Test input: ExprMatrix
  ### Other input classes:
  set.seed(123)
  sparseMat <- as(exprMatrix, "dgCMatrix")
  rSparse <- AUCell_run(sparseMat, geneSets, aucMaxRank=5)
  testthat::expect_equal(class(rSparse)[1], "aucellResults")
  
  set.seed(123)
  sexp <- SummarizedExperiment::SummarizedExperiment(assays=list(counts=exprMatrix))
  rSexp <- AUCell_run(sexp, geneSets, aucMaxRank=5)
  testthat::expect_equal(class(rSexp)[1], "aucellResults")
}

test_that("AUCell_run tests", test_AUCell_run())

## Methods created to manipulate GeneSets and GeneSetCollection
##
# Input:
# Output:

test_GeneSet_methods <- function()
{
  library(AUCell)
  ##################################################
  library(GSEABase)

  genes_1 <- GeneSet(paste("Gene", 1:20, sep=""), setName="geneSet1")
  genes_2 <- GeneSet(paste("Gene", 18:22, sep=""), setName="geneSet2")

  geneSets <- GeneSetCollection(genes_1, genes_2)

  ##################################################

  testthat::expect_equal(nGenes(genes_1), 20)
  testthat::expect_equal(nGenes(geneSets), setNames(c(20, 5), names(geneSets)))

  geneSets_subset <- subsetGeneSets(geneSets, paste("Gene", 15:20, sep=""))
  testthat::expect_equal(nGenes(geneSets_subset),
                         setNames(c(6, 3), names(geneSets)))
  testthat::expect_equal(length(unique(unlist(geneIds(geneSets_subset)))), 6)

  geneSets_newNames <- setGeneSetNames(geneSets, c("one", "two"))
  testthat::expect_equal(names(geneSets_newNames), c("one", "two"))
}

test_that("GeneSet_methods tests", test_GeneSet_methods())

## Class: aucellResults
##
# Input:
# Output:

test_aucellResults <- function()
{
  library(AUCell)
  ##################################################
  # Create objects
  set.seed(123)
  exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                       nrow=20)
  rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
  colnames(exprMatrix) <- paste("Cell", 1:500, sep="")
  
  cells_rankings <- suppressWarnings(AUCell_buildRankings(exprMatrix, plotStats=FALSE, verbose=FALSE))
  fewGenes <- sample(rownames(exprMatrix), 10)
  cellsAUC <- suppressWarnings(AUCell_calcAUC(fewGenes, cells_rankings, aucMaxRank=5))
  ##################################################

  # Ranking
  testthat::expect_equal(class(cells_rankings)[1], "aucellResults")
  testthat::expect_equal(dim(cells_rankings), c(20,500))

  testthat::expect_equal(dim(getRanking(cells_rankings)), c(20,500))
  testthat::expect_error(getAUC(cells_rankings))

  # AUC
  testthat::expect_equal(class(cellsAUC)[1], "aucellResults")
  testthat::expect_equal(dim(cellsAUC), c(1,500))

  testthat::expect_equal(dim(getAUC(cellsAUC)), c(1,500))
  testthat::expect_error(getRanking(cellsAUC))
  
  # cbind
  exprMatrix2 <- matrix(data=sample(c(rep(0, 100), sample(1:3, 20, replace=TRUE))),
                        nrow=20,
                        dimnames=list(paste("Gene", 1:20, sep=""),
                                      paste("Cell", 500:505, sep="")))
  cells_rankings2 <- suppressWarnings(AUCell_buildRankings(exprMatrix2, plotStats=FALSE, verbose=FALSE))
  
  ok <- cbind(cells_rankings, cells_rankings2[,-1]) 
  testthat::expect_error(cbind(cells_rankings, cells_rankings2[1:3,]))
  testthat::expect_error(cbind(cells_rankings, cells_rankings2))
  testthat::expect_error(rbind(cells_rankings, cells_rankings2))
}

test_that("aucellResults tests", test_aucellResults())

---
title: "AUCell: Identifying cells with active gene sets"
package: "`r pkg_ver('AUCell')`"
abstract: >
  This tutorial shows how to use **AUCell** to identify cells with an active 'gene set' (i.e. gene signatures) in single-cell RNA-seq data. 
  
  AUCell uses the "Area Under the Curve" (AUC) to calculate whether a critical subset of the input gene set is enriched within the expressed genes for each cell. The distribution of AUC scores across all the cells allows exploring the relative expression of the signature. Since the scoring method is ranking-based, AUCell is independent of the gene expression units and the normalization procedure. In addition, since the cells are evaluated individually, it can easily be applied to bigger datasets, subsetting the expression matrix if needed. 
vignette: >
  %\VignetteIndexEntry{AUCell: Identifying cells with active gene sets}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output: 
  BiocStyle::html_document:
    toc: yes
    number_sections: false
    css: corrected.css
  pdf_document:
    toc: yes
  html_notebook:
    toc: yes
---

```{r echo=FALSE, message=FALSE, warning=FALSE}
suppressPackageStartupMessages({
library(AUCell)
#library(Biobase)
library(GSEABase)
library(data.table)
library(DT)
library(NMF)
library(plotly)
library(GEOquery)
library(Matrix)
# library(doMC);library(doRNG) # Loaded by AUCell, to avoid messages. Not available in windows?
})

# To build a personalized report, update this working directory:
dir.create("AUCell_tutorial")
knitr::opts_knit$set(root.dir = 'AUCell_tutorial')
```

# Overview of the workflow
AUCell allows to identify cells with active gene sets (e.g. signatures, gene modules) in single-cell RNA-seq data. 

In brief, AUCell is run with these commands:

```{r Overview, eval=FALSE}
library(AUCell)
geneSets <- list(geneSet1=c("gene1", "gene2", "gene3"))

# Calculate enrichment scores
cells_AUC <- AUCell_run(exprMatrix, geneSets, aucMaxRank=nrow(cells_rankings)*0.05)

# Optional: Set the assignment thresholds
par(mfrow=c(3,3))
set.seed(123)
cells_assignment <- AUCell_exploreThresholds(cells_AUC, plotHist=TRUE, nCores=1, assign=TRUE)
```

In the following sections we explain the rationale behind the canculations and explore the output of each step. The details of the methods behind AUCell are described in the following article:
```{r citation, echo=FALSE}
print(citation("AUCell")[1], style="textVersion")
```
Please, also cite this article if you use AUCell in your research.


# Before starting
## Setup
By default, AUCell is installed only with the minimum dependencies. 
To run AUCell in parallel or run the examples in this tutorial, we recommend to install these packages:
  
```{r setup, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
# To support paralell execution:
BiocManager::install(c("doMC", "doRNG","doSNOW"))
# For the main example:
BiocManager::install(c("mixtools", "SummarizedExperiment"))
# For the examples in the follow-up section of the tutorial:
BiocManager::install(c("DT", "plotly", "NMF", "d3heatmap",
                       "dynamicTreeCut", "R2HTML", "Rtsne", "zoo"))
```

## Some tips...
### Help
At any time, remember you an access the help files for any function (i.e. `?AUCell_buildRankings`). It is also possible to open this tutorial directly from R with the following commands:
```{r vignette, eval=FALSE}
# Explore tutorials in the web browser:
browseVignettes(package="AUCell") 

# Commnad line-based:
vignette(package="AUCell") # list
vignette("AUCell") # open
```

### Report template
To generate an HTML report with your own data and comments, you can use the `.Rmd file` of this tutorial as template (i.e. copy the .Rmd file, and edit it as [R notebook](http://rmarkdown.rstudio.com/r_notebooks.html) in RStudio).


```{r editRmd, eval=FALSE}
vignetteFile <- paste(file.path(system.file('doc', package='AUCell')), "AUCell.Rmd", sep="/")
# Copy to edit as markdown
file.copy(vignetteFile, ".")
# Alternative: extract R code
Stangle(vignetteFile)
```

### Video tutorial

A video tutorial, created by a user ([Mark Sanborn](https://twitter.com/Sanbomics)), is also available in  [YouTube](https://www.youtube.com/watch?v=XtjZRZFzUVw).

*(Thank you Mark!)*

# Running AUCell

## 0. Load scRNA-seq dataset and gene sets
The input data for AUCell are the expression matrix and the gene-sets.

### Working directory
During this tutorial some plots and files are saved. To keep them tidy, we recommend to set the working directory to a new folder:
```{r setwd, eval=FALSE}
dir.create("AUCell_tutorial")
setwd("AUCell_tutorial") # or in the first code chunk (kntr options), if running as Notebook
```

### Expression matrix
The expression matrix, from a single-cell RNA-seq dataset, should be formatted with the genes/features as rows and cells as columns. Ideally, the matrix will be stored in sparse format to save memory.

Typically, this matrix will be loaded from a counts file, or from another R object. i.e.:
```{r loadingExprMat, eval=FALSE}
# i.e. Reading from a text file
exprMatrix <- read.table("myCountsMatrix.tsv")

# or single-cell experiment
exprMatrix <- assay(mySingleCellExperiment)

### Convert to sparse:
exprMatrix <- as(exprMatrix, "dgCMatrix")
```

In this tutorial we use a dataset containing 3005 cells from mouse cortex and hippocampus. The dataset can be downloaded from GEO accession number GSE60361.

*Zeisel, A., et al. (2015). Cell types in the mouse cortex and hippocampus revealed by single-cell RNA-seq. Science 347, 1138–1142. doi: [10.1126/science.aaa1934](http://dx.doi.org/10.1126/science.aaa1934)*


```{r GEOdataset, cache=TRUE, results='hide', message=FALSE, eval=TRUE}
# (Downloads the data)
if (!requireNamespace("GEOquery", quietly = TRUE)) BiocManager::install("GEOquery")
library(GEOquery)
# gse <- getGEO('GSE60361') # does not work, the matrix is in a suppl file
geoFile <- "GSE60361_C1-3005-Expression.txt.gz"
download.file("https://ftp.ncbi.nlm.nih.gov/geo/series/GSE60nnn/GSE60361/suppl/GSE60361_C1-3005-Expression.txt.gz", destfile = geoFile)

library(data.table)
exprMatrix <- fread(geoFile, sep="\t")
geneNames <- unname(unlist(exprMatrix[,1, with=FALSE]))
exprMatrix <- as.matrix(exprMatrix[,-1, with=FALSE])
rownames(exprMatrix) <- geneNames
exprMatrix <- exprMatrix[unique(rownames(exprMatrix)),]
dim(exprMatrix)
exprMatrix[1:5,1:4]

# Remove file(s) downloaded:
file.remove(geoFile)

# Convert to sparse
library(Matrix)
exprMatrix <- as(exprMatrix, "dgCMatrix")

# Save for future use
mouseBrainExprMatrix <- exprMatrix
save(mouseBrainExprMatrix, file="exprMatrix_MouseBrain.RData")
```

To speed-up the execution of the tutorial, we will use only 5000 random genes from this dataset.
```{r randomSamples}
# load("exprMatrix_MouseBrain.RData")
set.seed(333)
exprMatrix <- mouseBrainExprMatrix[sample(rownames(mouseBrainExprMatrix), 5000),]
```

In this way, we will be using an expression matrix with (`r nrow(exprMatrix)` gene and `r ncol(exprMatrix)` cells):
```{r dimExprMat}
dim(exprMatrix)
```

### Gene sets
The other input AUCell needs is the 'gene-sets' or signatures to test on the cells. 
They can be provided in several formats (see `?AUCell_calcAUC` for examples). e.g.:
```{r geneSetsFake}
library(GSEABase)
genes <- c("gene1", "gene2", "gene3")
geneSets <- GeneSet(genes, setName="geneSet1")
geneSets
```

In this example we will use gene-sets representing diferent cell types in the brain: 
  
  1. Big gene signatures (> 1000 genes) for **astrocytes**, **oligodendrocytes** and **neurons**.

  *Cahoy, J.D., et al. (2008). A Transcriptome Database for Astrocytes, Neurons, and Oligodendrocytes: A New Resource for Understanding Brain Development and Function. J. Neurosci. 28, 264–278. doi: [10.1523/JNEUROSCI.4178-07.2008](http://dx.doi.org/10.1523/JNEUROSCI.4178-07.2008)*
  
  2. Big gene signature (> 500 genes) for **microglia**. Obtained by comparing bulk RNA-seq profiles of microglia (brain-resident macrophages) to macrophages from other tissues. 

  *Lein, E.S., et al. (2007). Genome-wide atlas of gene expression in the adult mouse brain. Nature 445, 168–176.  doi: [10.1038/nature05453](http://dx.doi.org/10.1038/nature05453)* 
  
  3. Small gene signatures (<100 genes) for astrocytes and neurons.

  *Lavin, Y., et al. (2014) Tissue-Resident Macrophage Enhancer Landscapes Are Shaped by the Local Microenvironment. Cell 159, 1312–1326. doi: [10.1016/j.cell.2014.11.018](http://dx.doi.org/10.1016/j.cell.2014.11.018)*
  
```{r geneSets}
library(AUCell)
library(GSEABase)
gmtFile <- paste(file.path(system.file('examples', package='AUCell')), "geneSignatures.gmt", sep="/")
geneSets <- getGmt(gmtFile)
```

Let's check how many of these genes are in the expression matrix:
```{r geneSetsNgenes}
geneSets <- subsetGeneSets(geneSets, rownames(exprMatrix)) 
cbind(nGenes(geneSets))
```

To ease the interpretation of the tutorial, we will also add the gene-set size into its name:
```{r geneSetsRename}
geneSets <- setGeneSetNames(geneSets, newNames=paste(names(geneSets), " (", nGenes(geneSets) ,"g)", sep=""))
```

For the example, let's also add a few sets of random genes and 100 genes expressed in many cells (i.e. housekeeping-like):
```{r hkGs}
# Random
set.seed(321)
extraGeneSets <- c(
  GeneSet(sample(rownames(exprMatrix), 50), setName="Random (50g)"),
  GeneSet(sample(rownames(exprMatrix), 500), setName="Random (500g)"))

countsPerGene <- apply(exprMatrix, 1, function(x) sum(x>0))
# Housekeeping-like
extraGeneSets <- c(extraGeneSets,
                   GeneSet(sample(names(countsPerGene)[which(countsPerGene>quantile(countsPerGene, probs=.95))], 100), setName="HK-like (100g)"))

geneSets <- GeneSetCollection(c(geneSets,extraGeneSets))
names(geneSets)
```

Since we are using an expression matrix with only 5000 random genes, most of these genes are acutally not available in the dataset. 
However, AUCell is robust enough to use this 'noisy' data. 

## 1. Score gene signatures 

The function `AUCell_run` calculates calculates the signature enrichment scores on each cell:
```{r runAUCell, cache=TRUE}
cells_AUC <- AUCell_run(exprMatrix, geneSets)
save(cells_AUC, file="cells_AUC.RData")
```

> To run in parallel, you can add the argument `BPPARAM=BiocParallel::MulticoreParam(5)`. Modifiying `5` to the number of cores to use.

After obtaining the AUC scores, you can go directly to "Step 2" and "Follow up examples". However, you can keep reading through section 1.1 and 1.2 if you want to understand better what these scores mean, or if you would like to run AUCell across many gene-sets that need further manipulation.

In brief, the AUC scores are calculated in two steps: 1. Building the rankings (`AUCell_buildRankings`) and 2. Calculate enrichment (`AUCell_calcAUC`). i.e. using `AUCell_run` is equivalent to running:
```{r }
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=FALSE)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings)
```

### 1.1. Build gene-expression rankings for each cell
The first step to calculate the enrichment of a signature is to create the "rankings". These rankings are only an intermediate step to calculate the AUC, but they are kept as a separate step in the workflow in order to provide more flexibility (i.e. to save them for future analyses, to merge datasets, or process them by parts).

For each cell, the genes are ranked from highest to lowest value. The genes with same expression value are shuffled. Therefore, genes with expression '0' are randomly sorted at the end of the ranking. It is important to check that most cells have at least the number of expressed/detected genes that are going to be used to calculate the AUC (`aucMaxRank` in `calcAUC()`). The histogram provided by `AUCell_buildRankings()` allows to quickly check this distribution. `plotGeneCount(exprMatrix)` allows to obtain only the plot before building the rankings.

Since the rankings are created individually for each cell, in principle, it is possible to merge cell-rankings from different datasets. However, the datasets should be similar in regards to their "sensitivity" (e.g. the number of genes detected in the cells of each datasets), and the genes they include (e.g. same gene IDs).

```{r buildRankings, cache=TRUE, fig.width=5, fig.height=5}
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=TRUE)
```

```{r}
cells_rankings
```

The "rankings" can be seen as a new representation of the original dataset. Once they are calculated, they can be saved for future analyses. 

```{r saveRankings, eval=FALSE}
save(cells_rankings, file="cells_rankings.RData")
```

### 1.2. Calculate enrichment for the gene signatures (AUC)
To determine whether the gene set is enriched at the top of the gene-ranking for each cell, AUCell uses the "Area Under the Curve" (AUC) of the recovery curve.

```{r explainAUC, echo=FALSE}
geneSet <- geneSets[[1]]
gSetRanks <- cells_rankings[geneIds(geneSet),]

par(mfrow=c(1,2))
set.seed(222)
aucMaxRank <- nrow(cells_rankings)*0.05
na <- sapply(c(1, 2000), function(i){
  x <- sort(getRanking(gSetRanks[,i]))
  aucCurve <- cbind(c(0, x, nrow(cells_rankings)), c(0:length(x), length(x)))
  op <- par(mar=c(5, 6, 4, 2) + 0.1)
  plot(aucCurve, 
       type="s", col="darkblue", lwd=1, 
       xlab="Gene rank", ylab=paste("# genes in the gene set \n Gene set:", setName(geneSet)), 
       xlim=c(0, aucMaxRank*2), ylim=c(0, nGenes(geneSet)*.20), 
       main="Recovery curve", 
       sub=paste("Cell:", colnames(gSetRanks)[i]))
  aucShade <- aucCurve[which(aucCurve[,1] < aucMaxRank),]
  aucShade <- rbind(aucShade, c(aucMaxRank, nrow(aucShade)))
  aucShade[,1] <-  aucShade[,1]-1
  aucShade <- rbind(aucShade, c(max(aucShade),0))
  polygon(aucShade, col="#0066aa40", border=FALSE)
  
  abline(v=aucMaxRank, lty=2)
  text(aucMaxRank-50, 5, "AUC")
})
```

The function `AUCell_calcAUC` calculates this score, and returns a matrix with an AUC score for each gene-set in each cell.
```{r calcAUC, cache=TRUE, warning=FALSE}
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings)
save(cells_AUC, file="cells_AUC.RData")
```

In order to calculate the AUC, by default only the top 5% of the genes in the ranking are used (i.e. checks whether the genes in the gene-set or signature are within the top 5%). This allows faster execution on bigger datasets, and reduce the effect of the noise at the bottom of the ranking (e.g. where many genes might be tied at 0 counts). The percentage to take into account can be modified with the argument *aucMaxRank*. 
For datasets where most cells express many genes (e.g. a filtered dataset), or these have high expression values, it might be good to increase this threshold. Check the histogram provided by `AUCell_buildRankings` to get an estimation on where this threshold lies within the dataset.

## 2. Determine the cells with the given gene signatures or active gene sets

> *In summary:* The AUC represents the proportion of expressed genes in the signature, and their relative expression value compared to the other genes within the cell. 
We can use this propperty to explore the population of cells that are present in the dataset according to the expression of the gene-set. 

The AUC estimates the proportion of genes in the gene-set that are highly expressed in each cell. Cells expressing many genes from the gene-set will have higher AUC values than cells expressing fewer (i.e. compensating for housekeeping genes, or genes that are highly expressed in all the cells in the dataset). Since the AUC represents the proportion of expressed genes in the signature, we can use the relative AUCs across the cells to explore the population of cells that are present in the dataset according to the expression of the gene-set. 

However, determining whether the signature is active (or not) in a given cell is not always trivial. The AUC is not an absolute value, but it depends on the the cell type (i.e. sell size, amount of transcripts), the specific dataset (i.e. sensitivity of the measures) and the gene-set. It is often not straight forward to obtain a pruned *signature* of clear *marker* genes that are completely "on" in the cell type of interest and off" in every other cell. In addition, at single-cell level, most genes are not expressed or detected at a constant level.

The ideal situation will be a bi-modal distribution, in which most cells in the dataset have a low "AUC" compared to a population of cells with a clearly higher value (i.e. see "Oligodendrocites" in the next figure). This is normally the case on gene sets that are active mostly in a population of cells with a good representation in the dataset (e.g. ~ 5-30% of cells in the dataset). Similar cases of "marker" gene sets but with different proportions of cells in the datasets are the "neurons" and "microglia" (see figure). When there are very few cells within the dataset, the distribution might look normal-like, but with some outliers to the higher end (e.g. microglia). While if the gene set is marker of a high percentage of cells in the dataset (i.e. neurons), the distribution might start approaching the look of a gene-set of housekeeping genes. As example, the 'housekeeping' gene-set in the figure includes genes that are detected in most cells in the dataset.

Note that the size of the gene-set will also affect the results. With smaller gene-genes (fewer genes), it is more likely to get cells with AUC = 0. 
While this is the case of the "perfect markers" it is also easier to get it by chance with smal datasets. (i.e. Random gene set with 50 genes in the figure). Bigger gene-sets (100-2k) can be more stable and easier to evaluate, as big random gene sets will approach the normal distibution.

To ease the exploration of the distributions, the function `AUCell_exploreThresholds()` automatically plots all the histograms and calculates several thresholds that could be used to consider a gene-set 'active' (returned in `$aucThr`). The distributions are plotted as dotted lines over the histogram and the corresponding thresholds as vertical bars in the matching color. The thicker vertical line indicates the threshold selected by default (`$aucThr$selected`): the highest value to reduce the false positives. 

> Note: This function makes use of package "mixtools" to explore the distributions. It is not essential, but we recommend to install it: `if (!requireNamespace("BiocManager", quietly=TRUE)); BiocManager::install("mixtools")`
     `install.packages("BiocManager"); BiocManager::install("mixtools")`

```{r exploreThresholds, warning=FALSE, fig.width=7, fig.height=7}
set.seed(333)
par(mfrow=c(3,3)) 
cells_assignment <- AUCell_exploreThresholds(cells_AUC, plotHist=TRUE, assign=TRUE) 
warningMsg <- sapply(cells_assignment, function(x) x$aucThr$comment)
warningMsg[which(warningMsg!="")]
```

The thresholds calcuated for each gene set are stored in the `$aucThr` slot. 
For example, the thresholds suggested for the oligodendrocyte gene-set: 
```{r explThr1}
cells_assignment$Oligodendrocyte_Cahoy$aucThr$thresholds
```

To ease for the inclusion of AUCell in workflows (e.g. SCENIC), this function can also provide the list of cells with an AUC value over this threshold (`$assignment`). However, keep in mind that the threshold selection in the current version is not exhaustive, so we highly recommend to check the AUC histograms and manually select the threshold if needed. 

To obtain the threshold selected automatically for a given gene set(e.g. Oligodendrocytes):
```{r explThr2}
cells_assignment$Oligodendrocyte_Cahoy$aucThr$selected
# getThresholdSelected(cells_assignment)
```
Cells assigned at this threshold:
```{r cellsAssigned}
oligodencrocytesAssigned <- cells_assignment$Oligodendrocyte_Cahoy$assignment
length(oligodencrocytesAssigned)
head(oligodencrocytesAssigned)
```

Plotting the AUC histogram of a specific gene set, and setting a new threshold:
```{r AUCell_plot}
geneSetName <- rownames(cells_AUC)[grep("Oligodendrocyte_Cahoy", rownames(cells_AUC))]
AUCell_plotHist(cells_AUC[geneSetName,], aucThr=0.25)
abline(v=0.25)
```
Assigning cells to this new threshold:
```{r explThr3}
newSelectedCells <- names(which(getAUC(cells_AUC)[geneSetName,]>0.08))
length(newSelectedCells)
head(newSelectedCells)
```

# Follow up examples
## Exploring the cell-assignment (table & heatmap)

The cell assignment is stored in the `$assignment` slot. Here we show a few ideas on how they can be extracted and visualized.

Extract these cells for all the gene-sets and transform it into a table:
```{r explAssignment}
cellsAssigned <- lapply(cells_assignment, function(x) x$assignment)
assignmentTable <- reshape2::melt(cellsAssigned, value.name="cell")
colnames(assignmentTable)[2] <- "geneSet"
head(assignmentTable)
```

Convert into an incidence matrix and plot as a histogram:
```{r assignmentMat}
assignmentMat <- table(assignmentTable[,"geneSet"], assignmentTable[,"cell"])
assignmentMat[,1:2]
```

```{r assignHeatmap}
set.seed(123)
miniAssigMat <- assignmentMat[,sample(1:ncol(assignmentMat),100)]
library(NMF)
aheatmap(miniAssigMat, scale="none", color="black", legend=FALSE)
```

Some interactive options (output not shown):
```{r assignHeatmap_interactive, eval=FALSE}
# if (!requireNamespace("d3heatmap", quietly = TRUE)) BiocManager::install("d3heatmap")
# d3heatmap(matrix(miniAssigMat), scale="none", colors=c("white", "black"))

library(DT)
datatable(assignmentTable, options = list(pageLength = 10), filter="top")
```

## Explore cells/clusters based on the signature score

The AUC score can also be used to explore the output from previous clustering analyses (or vice-versa).

In this example, we will use the AUC obtained for the diferent signatures to color a t-SNE based previously run on the whole expression matrix (i.e. not the 5000 random genes).

```{r loadtSNE, fig.width=4, fig.height=4}
# Load the tSNE (included in the package)
load(paste(file.path(system.file('examples', package='AUCell')), "cellsTsne.RData", sep="/"))
cellsTsne <- cellsTsne$Y
plot(cellsTsne, pch=16, cex=.3)
```

This t-SNE was created with this code (it takes a while to run):
```{r runTsne, eval=FALSE}
load("exprMatrix_AUCellVignette_MouseBrain.RData")
sumByGene <- apply(mouseBrainExprMatrix, 1, sum)
exprMatSubset <- mouseBrainExprMatrix[which(sumByGene>0),]
logMatrix <- log2(exprMatSubset+1)
logMatrix <- as.matrix(logMatrix)

library(Rtsne)
set.seed(123)
cellsTsne <- Rtsne(t(logMatrix))
rownames(cellsTsne$Y) <- colnames(logMatrix)
colnames(cellsTsne$Y) <- c("tsne1", "tsne2")
save(cellsTsne, file="cellsTsne.RData")
```

This t-SNE can be colored based on the AUC scores. To highlight the cluster of cells that are more likely of the cell type according to the signatures, we will split the cells into the cells that pass the assignment threshold (colored in shades of pink-red), and the cells that don't (colored in black-blue). 

Of course, the origin of the signatures should also be kept in mind for the interpretation (for example, these signatures were obtained from bulk RNA-seq analyses). Also, running this tutorial only on 5000 genes probably introduced some extra noise.

For this example we have used the thresholds assigned automatically:
```{r plotTsneCode, fig.width=7, fig.height=6}
selectedThresholds <- getThresholdSelected(cells_assignment)
par(mfrow=c(2,3)) # Splits the plot into two rows and three columns
for(geneSetName in names(selectedThresholds)[1:6])
{
  nBreaks <- 5 # Number of levels in the color palettes
  # Color palette for the cells that do not pass the threshold
  colorPal_Neg <- grDevices::colorRampPalette(c("black","blue", "skyblue"))(nBreaks)
  # Color palette for the cells that pass the threshold
  colorPal_Pos <- grDevices::colorRampPalette(c("pink", "magenta", "red"))(nBreaks)
  
  # Split cells according to their AUC value for the gene set
  passThreshold <- getAUC(cells_AUC)[geneSetName,] >  selectedThresholds[geneSetName]
  if(sum(passThreshold) >0 )
  {
    aucSplit <- split(getAUC(cells_AUC)[geneSetName,], passThreshold)
    
    # Assign cell color
    cellColor <- c(setNames(colorPal_Neg[cut(aucSplit[[1]], breaks=nBreaks)], names(aucSplit[[1]])), 
    setNames(colorPal_Pos[cut(aucSplit[[2]], breaks=nBreaks)], names(aucSplit[[2]])))
    
    # Plot
    plot(cellsTsne, main=geneSetName,
    sub="Pink/red cells pass the threshold",
    col=cellColor[rownames(cellsTsne)], pch=16) 
  }
}
```

This kind of plots can also be used to explore the assignment thresholds. i.e.:
```{r tsneThreshold}
selectedThresholds[2] <-  0.25
par(mfrow=c(2,3))
AUCell_plotTSNE(tSNE=cellsTsne, exprMat=exprMatrix, 
cellsAUC=cells_AUC[1:2,], thresholds=selectedThresholds)
```

# Why to use AUCell? 

## Comparison with mean 

One of the most intuitive ways to evaluate the expression of a gene signature is to calculate the mean expression. However, calculating the average of the gene signature on the raw counts will lead to cells with more reads (either for technical or biological reasons) to have higher average values for most signatures. To reduce this effect, some kind of library-size normalization would be required. 
Since AUCell evaluates the dectection of the signatures on each cell individually, it automatically compensates for library-size and makes its application easier and independent of the units of the data and other normalizations applied  (e.g. raw counts, TPM, UMI counts).

```{r}
logMat <- log2(exprMatrix+2)
meanByGs <- t(sapply(geneSets, function(gs) colMeans(logMat[geneIds(gs),])))
rownames(meanByGs) <- names(geneSets)
```

```{r meanTsne, fig.width=7, fig.height=8}
colorPal <- grDevices::colorRampPalette(c("black", "red"))(nBreaks)
par(mfrow=c(3,3))
for(geneSetName in names(geneSets))
{
  cellColor <- setNames(colorPal[cut(meanByGs[geneSetName,], breaks=nBreaks)], names(meanByGs[geneSetName,]))
  plot(cellsTsne, main=geneSetName, axes=FALSE, xlab="", ylab="",
  sub="Expression mean",
  col=cellColor[rownames(cellsTsne)], pch=16)
}

AUCell_plotTSNE(tSNE=cellsTsne, exprMat=exprMatrix, plots = "AUC",
cellsAUC=cells_AUC[1:9,], thresholds=selectedThresholds)
```

```{r, fig.height=4, fig.width=3.5}
nGenesPerCell <- apply(exprMatrix, 2, function(x) sum(x>0))
colorPal <- grDevices::colorRampPalette(c("darkgreen", "yellow","red"))
cellColorNgenes <- setNames(adjustcolor(colorPal(10), alpha.f=.8)[as.numeric(cut(nGenesPerCell,breaks=10, right=FALSE,include.lowest=TRUE))], names(nGenesPerCell))
plot(cellsTsne, axes=FALSE, xlab="", ylab="",
sub="Number of detected genes",
col=cellColorNgenes[rownames(cellsTsne)], pch=16)
```

## How reliable is AUCell? (Confusion matrix)

When using AUCell to identify cell types, the reliability of the cells identified will depend on the signatures used, and the differences within the cell types in the dataset. In any case, AUCell is quite robust to noise, both in the data and in the gene-set. 

This is the comparison of the cells identified with AUCell (this example) and the cell-types assigned in the initial publication:

```{r}
# "Real" cell type (e.g. provided in the publication)
cellLabels <- paste(file.path(system.file('examples', package='AUCell')), "mouseBrain_cellLabels.tsv", sep="/")
cellLabels <- read.table(cellLabels, row.names=1, header=TRUE, sep="\t")
```

```{r}
# Confusion matrix:
cellTypeNames <- unique(cellLabels[,"level1class"])
confMatrix <- t(sapply(cells_assignment[c(1,4,2,5,3,6:9)], 
function(x) table(cellLabels[x$assignment,])[cellTypeNames]))
colnames(confMatrix) <- cellTypeNames
confMatrix[which(is.na(confMatrix), arr.ind=TRUE)] <- 0
confMatrix
```

*Notes on interpretation*: 

- Interneurons & pyramidal are "neurons". 

- According to other publications that have used this dataset to evaluate new methods, a relevant group of cells marked as oligodendrocytes are likely doublets (i.e. two cells, for example a mix of an oligodendrocyte + another cell type).

# sessionInfo

This is the output of `sessionInfo()` on the system on which this document was compiled:
```{r}
date()
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/03_exploreThresholds.R, R/aux_thresholds.R
\name{AUCell_exploreThresholds}
\alias{AUCell_exploreThresholds}
\alias{getThresholdSelected}
\alias{getAssignments}
\title{AUCell_exploreThresholds}
\usage{
AUCell_exploreThresholds(
  cellsAUC,
  thrP = 0.01,
  nCores = 1,
  smallestPopPercent = 0.25,
  plotHist = TRUE,
  densAdjust = 2,
  assignCells = FALSE,
  nBreaks = 100,
  verbose = TRUE
)

getThresholdSelected(aucellThresholds)

getAssignments(aucellThresholds)
}
\arguments{
\item{cellsAUC}{AUC object returned by \code{\link{AUCell_calcAUC}}.}

\item{thrP}{Probability to determine outliers in some of the distributions
 (see 'details' section).

By default it is set to 1\% (thrP):
if there are 3000 cells in the dataset,
it is expected that approximately 30 cells are over this threshold
if the AUC is normally distributed.}

\item{nCores}{Number of cores to use for computation.}

\item{smallestPopPercent}{Size (percentage) of the smallest population
of cells expected. Used to calculate some of the thresholds.}

\item{plotHist}{Whether to plot the AUC histograms. (TRUE / FALSE)}

\item{densAdjust}{Parameter for the density curve. (See \code{density} for details).}

\item{assignCells}{Return the list of cells that pass the
automatically selected threshold? (TRUE/FALSE)}

\item{nBreaks}{Number of bars to plot in the histograms.}

\item{verbose}{Should the function show progress messages? (TRUE / FALSE)}

\item{aucellThresholds}{For aux functions: Output from AUCell_exploreThresholds}
}
\value{
List with the following elements for each gene-set:
\itemize{
\item 'aucThr' Thresholds calculated with each method (see 'details' section),
and the number of cells that would be assigned using that threshold.

If assignCells=TRUE, the threshold selected automatically is the highest
value (in most cases, excluding the global distribution).
\item 'assignment' List of cells that pass the selected AUC threshold (if \code{assignCells=TRUE})
}
If \code{plotHist=TRUE} the AUC histogram is also plot,
including the distributions calculated and the corresponding thresholds
in the same color (dashed vertical lines).
The threshold that is automatically selected is shown as a thicker
 non-dashed vertical line.
}
\description{
Plots all the AUC histograms (per gene-set)
and calculates several likely thresholds for each gene-set
}
\details{
To ease the selection of an assignment theshold,
this function adjusts the AUCs of each gene-set to several distributions
 and calculates possible thresholds:
\itemize{
\item \code{minimumDens} (plot in Blue):
Inflection point of the density curve.
This is usually a good option for the ideal situation
with bimodal distributions.

To avoid false positives, by default this threshold will not be chosen
if the second distribution is higher
(i.e. the majority of cells have the gene-set "active").
\item \code{L_k2} (plot in Red): Left distribution,
after adjusting the AUC to a mixture of two distributions.
The threshold is set to the right (prob: \code{1-(thrP/nCells)}).
Only available if 'mixtools' package is installed.
\item \code{R_k3} (plot in Pink): Right distribution,
after adjusting the AUC to a mixture of three distributions.
The threshold is set to the left (prob: \code{thrP}).
Only available if 'mixtools' package is installed.
\item \code{Global_k1} (plot in Grey): "global" distribution
(i.e. mean and standard deviations of all cells).
The threshold is set to the right (prob: \code{1-(thrP/nCells)}).

The threshold based on the global distribution is ignored from the automatic
selection unless the mixed models are overlapping.
}
Note: If \code{assignCells=TRUE}, the highest threshold is used to select cells.
However, keep in mind that this function is only meant to ease the selection
of the threshold, and we highly recommend to look at the AUC histograms and
adjust the threshold manually if needed.
We recommend to be specially aware on gene-sets with few genes (10-15) and
thresholds that are set extremely low.
}
\examples{
# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
dim(exprMatrix)
##################################################

######### Previous steps in the workflow #########
# Step 1.
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=FALSE)

# Step 2.
# (Gene sets: random genes)
geneSets <- list(geneSet1=sample(rownames(exprMatrix), 10),
                 geneSet2=sample(rownames(exprMatrix), 5))
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)
##################################################

############## Step 3: Assign cells ##############

# 1. Plot histograms and obtain some pre-computed thresholds
# (this example is only meant to show the interface/arguments of the function,
# see the vignette for meaningful examples)
set.seed(123)
par(mfrow=c(1,2)) # Plot is divided into one row and two columns
thresholds <- AUCell_exploreThresholds(cells_AUC, plotHist=TRUE)
thresholds$geneSet1$aucThr

# 2. Obtain cells over a given threshold:
names(which(getAUC(cells_AUC)["geneSet1",] > 0.19))

# Alternative 1: assign cells according to the 'automatic' threshold
cells_assignment <- AUCell_exploreThresholds(cells_AUC,
                                             plotHist=FALSE, assignCells=TRUE)
# Cells assigned:
getAssignments(cells_assignment)
# Threshold applied:
getThresholdSelected(cells_assignment)

# Alternative 2: choose a threshold manually and assign cells
newThresholds = getThresholdSelected(cells_assignment)
newThresholds['geneSet1'] = 0.8
newAssignments = AUCell_assignCells(cells_AUC, newThresholds)
getAssignments(newAssignments)



}
\seealso{
Previous step in the workflow: \code{\link{AUCell_calcAUC}}.

See the package vignette for examples and more details:
\code{vignette("AUCell")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class_aucellResults.R
\docType{class}
\name{aucellResults-class}
\alias{aucellResults-class}
\alias{aucellResults}
\alias{getAUC}
\alias{getRanking}
\alias{show}
\alias{cbind}
\alias{show,aucellResults-method}
\alias{getAUC,aucellResults-method}
\alias{getRanking,aucellResults-method}
\alias{cbind,aucellResults-method}
\alias{rbind}
\alias{rbind,aucellResults-method}
\title{Wrapper to the matrix that stores the AUC or the cell rankings.}
\usage{
\S4method{show}{aucellResults}(object)

getAUC(object)

\S4method{getAUC}{aucellResults}(object)

getRanking(object)

\S4method{getRanking}{aucellResults}(object)

\S4method{cbind}{aucellResults}(..., deparse.level = 1)

\S4method{rbind}{aucellResults}(..., deparse.level = 1)
}
\arguments{
\item{object}{Results from \code{AUCell_buildRanking}}

\item{...}{(Only for cbind) 

or \code{AUCell_calcAUC}.}

\item{deparse.level}{(Only for cbind)}
}
\value{
\itemize{
\item show: Prints a summary of the object
\item getAUC: Returns the matrix containing the AUC
\item getRanking: Returns the matrix containing the rankings
\item cbind: Combines objects by columns (cbind on \code{assays}); other other slots are conserved from the first object provided as argument.
Both, ranking and AUC are calculated by column (cell or sample). Therefore, it is fine to merge objects as long as they come from equivalent datasets (and keep same genes/genesets, etc...)
}
}
\description{
This class extends SummarizedExperiment to contain the AUC matrix and cell
rankings (as 'assays').

The results are stored in the assays slot, but they can be accessed through
the regular methods (i.e. nrow, rownames... )

Types:

 - "AUC": The assays contains the AUC for the gene-sets (or region-sets)
 & cells.

 - "ranking": The assays contains the gene rankings for each cell.
}
\examples{
# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.


############# Fake run of AUCell #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
dim(exprMatrix)

# Running AUCell
cells_rankings <- AUCell_buildRankings(exprMatrix)
fewGenes <- sample(rownames(exprMatrix), 10)
otherGenes <- sample(rownames(exprMatrix), 5)
geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5, nCores=1)
##############################################

#Exploring the output:
cells_AUC

class(cells_AUC)

# Extracting the AUC matrix:
getAUC(cells_AUC)[,1:5]

# Subsetting and regular manipulation methods are also available:
cells_AUC[1:2,]
cells_AUC[,3:4]

dim(cells_AUC)
nrow(cells_AUC)
ncol(cells_AUC)
colnames(cells_AUC)
rownames(cells_AUC)

### Merging 2 objects (ranking or AUC):
sample1 <- cells_AUC[,10:20]
sample2 <- cells_AUC[,100:140]
cbind(sample1, sample2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_updateAucellResults.R
\name{updateAucellResults}
\alias{updateAucellResults}
\title{Update AUCell results}
\usage{
updateAucellResults(oldAucObject, objectType = "AUC")
}
\arguments{
\item{oldAucObject}{Object to update}

\item{objectType}{Either "AUC" or "ranking" indicating the object type}
}
\value{
Updated version of the object as \code{\link{aucellResults}}.
}
\description{
Updates the AUC scores provided by AUCell from a previous version.
}
\examples{
oldAuc <- matrix(data=1:2000, nrow=50, ncol=40)
updateAucellResults(oldAuc)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_orderAUC.R
\name{orderAUC}
\alias{orderAUC}
\title{orderAUC}
\usage{
orderAUC(auc)
}
\arguments{
\item{auc}{AUC (as returned by calcAUC)}
}
\value{
gene-set names in the suggested order
}
\description{
Reorder the gene-sets based on AUC similarity
}
\examples{
# cellsAUC <- cellsAUC[orderAUC(cellsAUC),]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_plotGeneCount.R
\name{plotGeneCount}
\alias{plotGeneCount}
\title{plotGeneCount}
\usage{
plotGeneCount(exprMat, plotStats = TRUE, verbose = TRUE)
}
\arguments{
\item{exprMat}{Expression matrix (genes as rows, cells as columns)}

\item{plotStats}{Logical. If true, it plots the histogram, otherwise only calculates the percentages of genes detected.}

\item{verbose}{Should the function show progress messages? (TRUE / FALSE)}
}
\value{
Quantiles with the number of genes detected by cell (invisible).
his result is also printed if verbose=TRUE.
}
\description{
Plots a histogram and boxplot for the number of genes
detected in each cell.
}
\details{
It is important to check that most cells have at least the number of
expressed/detected genes that are going to be used to calculate the AUC
(`aucMaxRank` in `calcAUC()`). The histogram provided by
`AUCell_buildRankings()` allows to quickly check this distribution.
`plotGeneCount(exprMatrix)` allows to obtain only the plot before
building the rankings.
}
\examples{
### (Fake expression matrix)
exprMatrix <- matrix(sample(c(rep(0, 500), sample(1:3, 500, replace=TRUE))),
 nrow=20)
rownames(exprMatrix) <- paste("Gene", 1:20, sep="")
colnames(exprMatrix) <- paste("Sample", 1:50, sep="")
###

plotGeneCount(exprMatrix)
title(sub="Fake expression matrix")

}
\seealso{
See the package vignette for more details: \code{vignette("AUCell")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_getSetNames.R
\name{getSetNames}
\alias{getSetNames}
\title{Get gene set name (excluding number of genes/regions after space)}
\usage{
getSetNames(aucMat, patterns, startChr = "^", endChr = " |_")
}
\arguments{
\item{aucMat}{AUC matrix}

\item{patterns}{patterns}

\item{startChr}{Character to indicate the start (typically "^")}

\item{endChr}{Character at the end of the gene set name, i.e. space or "_" after a transcription factor name}
}
\value{
Returns the gene set name (i.e. selects the given pattern)
}
\description{
Returns the gene set name (i.e. selects the given pattern)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_AUCell_plotTSNE.R
\name{AUCell_plotTSNE}
\alias{AUCell_plotTSNE}
\title{Plot}
\usage{
AUCell_plotTSNE(
  tSNE,
  exprMat = NULL,
  cellsAUC = NULL,
  thresholds = NULL,
  reorderGeneSets = FALSE,
  cex = 1,
  alphaOn = 1,
  alphaOff = 0.2,
  borderColor = adjustcolor("lightgray", alpha.f = 0.1),
  offColor = "lightgray",
  plots = c("histogram", "binaryAUC", "AUC", "expression"),
  exprCols = c("goldenrod1", "darkorange", "brown"),
  asPNG = FALSE,
  ...
)
}
\arguments{
\item{tSNE}{t-SNE coordinates (e.g. \code{tSNE$Y})}

\item{exprMat}{Expression matrix}

\item{cellsAUC}{AUC (as returned by calcAUC)}

\item{thresholds}{Thresholds returned by AUCell}

\item{reorderGeneSets}{Whether to reorder the gene sets based on AUC similarity}

\item{cex}{Scaling factor for the dots in the scatterplot}

\item{alphaOn}{Transparency for the dots representing "active" cells}

\item{alphaOff}{Transparency for the dots representing "inactive" cells}

\item{borderColor}{Border color for the dots (scatterplot)}

\item{offColor}{Color for the dots representing "inactive" cells}

\item{plots}{Which plots to generate? Select one or multiple: \code{plots=c("histogram", "binaryAUC", "AUC", "expression")}}

\item{exprCols}{Color scale for the expression}

\item{asPNG}{Output each individual plot in a .png file? (can also be a directory)}

\item{...}{Other arguments to pass to \code{\link{hist}} function.}
}
\value{
Returns invisible: \code{cells_trhAssignment}
}
\description{
Plots the AUC histogram and t-SNE coloured by AUC, binary activity and TF expression
}
\details{
To avoid calculating thresholds, set thresholds to FALSE
}
\examples{


######
# Fake run of AUCell
set.seed(123)
exprMatrix <- matrix(
  data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
  nrow=20, 
  dimnames=list(paste("Gene", 1:20, sep=""), 
                paste("Cell", 1:500, sep="")))
geneSets <- list(geneSet1=sample(rownames(exprMatrix), 10),
                 geneSet2=sample(rownames(exprMatrix), 5))

cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats = FALSE)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5, nCores=1)
selectedThresholds <- rowMeans(getAUC(cells_AUC))
cellsTsne<- Rtsne::Rtsne(t(exprMatrix),max_iter = 10)$Y
# cellsTsne<- tsne::tsne(t(exprMatrix),max_iter = 10)
rownames(cellsTsne) <- colnames(exprMatrix)
######


par(mfrow=c(2,3))
thrs <- AUCell_plotTSNE(tSNE=cellsTsne, exprMat=NULL,
                        cellsAUC=cells_AUC, thresholds=selectedThresholds, 
                        plots = c("histogram", "binaryAUC", "AUC"))
 


#####
# Color based on the known phenodata:
cellInfo <- data.frame(cellType1=sample(LETTERS[1:3],ncol(exprMatrix), replace=TRUE), 
                       cellType2=sample(letters[5:7],ncol(exprMatrix), replace=TRUE), 
                       nGenes=abs(rnorm(ncol(exprMatrix))), 
                       row.names=colnames(exprMatrix))
colVars <- list(cellType2=setNames(c("skyblue","magenta", "darkorange"),letters[5:7]))
# dev.off()
plotTsne_cellProps(cellsTsne, cellInfo, colVars=colVars)

}
\seealso{
List of vignettes included in the package: \code{vignette(package="AUCell")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_methods.R
\docType{methods}
\name{nGenes}
\alias{nGenes}
\alias{nGenes,GeneSet-method}
\alias{nGenes,GeneSetCollection-method}
\alias{subsetGeneSets}
\alias{subsetGeneSets,GeneSetCollection-method}
\alias{setGeneSetNames}
\alias{setGeneSetNames,GeneSetCollection-method}
\title{GeneSet methods}
\usage{
nGenes(geneSet)

\S4method{nGenes}{GeneSet}(geneSet)

\S4method{nGenes}{GeneSetCollection}(geneSet)

subsetGeneSets(geneSets, geneNames)

\S4method{subsetGeneSets}{GeneSetCollection}(geneSets, geneNames)

setGeneSetNames(geneSets, newNames)

\S4method{setGeneSetNames}{GeneSetCollection}(geneSets, newNames)
}
\arguments{
\item{geneSet}{One gene-set (\code{\link{GeneSet}})}

\item{geneSets}{Gene-set collection
(\code{\link{GeneSetCollection}})}

\item{geneNames}{Gene names (for subset)}

\item{newNames}{New names (to assign to the gene sets)}
}
\value{
- **nGenes()**: provides the number of genes in the gene-set,
or each of the gene-sets in a collection

- **subsetGeneSets()**: Subsets each of the gene-sets in a collection
to contain only the genes inthe given list. Equivalent to intersect(),
but keeping the original gene-set name.

- **setGeneSetNames()**: Modifies the name of each gene-set in a collection
}
\description{
Functions to manipulate GeneSet and GeneSetCollection objects
(from package GSEABase)
}
\examples{
library(GSEABase)
genes_1 <- GeneSet(paste("Gene", 1:20, sep=""), setName="geneSet1")
genes_2 <- GeneSet(paste("Gene", 18:22, sep=""), setName="geneSet2")
geneSets <- GeneSetCollection(genes_1, genes_2)

nGenes(genes_1)
nGenes(geneSets)

subsetGeneSets(geneSets, paste("Gene", 15:20, sep=""))

geneSets_newNames <- setGeneSetNames(geneSets, c("one", "two"))
names(geneSets_newNames)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/02_calcAUC.R
\name{AUCell_calcAUC}
\alias{AUCell_calcAUC}
\alias{AUCell_calcAUC,list-method}
\alias{AUCell_calcAUC,character-method}
\alias{AUCell_calcAUC,GeneSet-method}
\alias{AUCell_calcAUC,GeneSetCollection-method}
\title{Calculate AUC}
\usage{
AUCell_calcAUC(
  geneSets,
  rankings,
  nCores = 1,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(rankings)),
  verbose = TRUE
)

\S4method{AUCell_calcAUC}{list}(
  geneSets,
  rankings,
  nCores = 1,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(rankings)),
  verbose = TRUE
)

\S4method{AUCell_calcAUC}{character}(
  geneSets,
  rankings,
  nCores = 1,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(rankings)),
  verbose = TRUE
)

\S4method{AUCell_calcAUC}{GeneSet}(
  geneSets,
  rankings,
  nCores = 1,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(rankings)),
  verbose = TRUE
)

\S4method{AUCell_calcAUC}{GeneSetCollection}(
  geneSets,
  rankings,
  nCores = 1,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(rankings)),
  verbose = TRUE
)
}
\arguments{
\item{geneSets}{List of gene-sets (or signatures) to test in the cells.
The gene-sets should be provided as \code{\link{GeneSet}},
\code{\link{GeneSetCollection}} or character list (see examples).}

\item{rankings}{'Rankings' created for this dataset with
\code{\link{AUCell_buildRankings}}.}

\item{nCores}{Number of cores to use for computation.}

\item{normAUC}{Wether to normalize the maximum possible AUC to 1 (Default: TRUE).}

\item{aucMaxRank}{Threshold to calculate the AUC (see 'details' section)}

\item{verbose}{Should the function show progress messages? (TRUE / FALSE)}
}
\value{
Matrix with the AUC values (gene-sets as rows, cells as columns).
}
\description{
Calculates the 'AUC' for each gene-set in each cell.
}
\details{
In a simplified way, the AUC value represents the fraction of genes,
 within the top X genes in the ranking, that are included in the signature.
The parameter 'aucMaxRank' allows to modify the number of genes
(maximum ranking) that is used to perform this computation.
By default, it is set to 5\% of the total number of genes in the rankings.
Common values may range from 1 to 20\%.
}
\examples{
# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
##################################################

######### Previous step in the workflow ##########
# Step 1.
cells_rankings <- AUCell_buildRankings(exprMatrix)
##################################################

############## Step 2: Calculate AUC #############

# In this example we use two gene sets: 10 and 5 random genes
# (see other formatting examples at the end)
fewGenes <- sample(rownames(exprMatrix), 10)
otherGenes <- sample(rownames(exprMatrix), 5)

geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
geneSets

# Calculate AUC with the rankings from Step 1.
# To be able to run this fake example (which contain only 20 genes),
# we use aucMaxRank=5 (top 25\% of the genes in the ranking)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5, nCores=1)

# Format of the output:
cells_AUC

# To subset & access the AUC slot (as matrix):
cells_AUC[1:2,]
cells_AUC[,3:4]
getAUC(cells_AUC)[,1:5]


# These methods are also available:
dim(cells_AUC)
nrow(cells_AUC)
ncol(cells_AUC)
colnames(cells_AUC)[1:4]
rownames(cells_AUC)

#########################################################
# Alternatives for the input of gene sets:

# a) Character vector (i.e. only one gene-set)
# It will take the default name 'geneSet'
fewGenes
test <- AUCell_calcAUC(fewGenes, cells_rankings, aucMaxRank=5)

# b) List
geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
geneSets
test <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)

# c) GeneSet object (from GSEABase)
library(GSEABase)
geneSetOne <- GeneSet(fewGenes, setName="geneSetOne")
geneSetOne
test <- AUCell_calcAUC(geneSetOne, cells_rankings, aucMaxRank=5)


# d) GeneSetCollection object (from GSEABase)
geneSetTwo <- GeneSet(otherGenes, setName="geneSetTwo")
geneSets <- GeneSetCollection(geneSetOne, geneSetTwo)
geneSets
test <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)
}
\seealso{
Previous step in the workflow: \code{\link{AUCell_buildRankings}}.
Next step in the workflow: \code{\link{AUCell_exploreThresholds}}.

See the package vignette for examples and more details:
\code{vignette("AUCell")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_AUCell_run_byBlocks.R
\name{AUCell_run}
\alias{AUCell_run}
\alias{AUCell_run,dgCMatrix-method}
\alias{AUCell_run,matrix-method}
\alias{AUCell_run,SummarizedExperiment-method}
\title{Run AUCell}
\usage{
AUCell_run(
  exprMat,
  geneSets,
  featureType = "genes",
  keepZeroesAsNA = FALSE,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(exprMat)),
  BPPARAM = NULL,
  ...
)

\S4method{AUCell_run}{dgCMatrix}(
  exprMat,
  geneSets,
  featureType = "genes",
  keepZeroesAsNA = FALSE,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(exprMat)),
  BPPARAM = NULL
)

\S4method{AUCell_run}{matrix}(
  exprMat,
  geneSets,
  featureType = "genes",
  keepZeroesAsNA = FALSE,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(exprMat)),
  BPPARAM = NULL
)

\S4method{AUCell_run}{SummarizedExperiment}(
  exprMat,
  geneSets,
  featureType = "genes",
  keepZeroesAsNA = FALSE,
  normAUC = TRUE,
  aucMaxRank = ceiling(0.05 * nrow(exprMat)),
  BPPARAM = NULL,
  assayName = NULL
)
}
\arguments{
\item{exprMat}{Expression matrix (genes/regions as rows, cells as columns)
The expression matrix can also be provided as one of the R/Bioconductor classes:
\itemize{
\item \link[Matrix]{dgCMatrix-class}:
Sparse matrix 
\item \link{RangedSummarizedExperiment} and derived classes (e.g. \link[SingleCellExperiment]{SingleCellExperiment} ):
The matrix will be obtained through assay(exprMatrix),
-which will extract the first assay (usually the counts)-
or the assay name given in 'assayName'
}}

\item{geneSets}{List of gene-sets (or signatures) to test in the cells.
The gene-sets should be provided as \code{\link{GeneSet}},
\code{\link{GeneSetCollection}} or character list (see examples).}

\item{featureType}{Name for the rows (e.g. "genes"). Only for naming the rankings, not used internally.}

\item{keepZeroesAsNA}{Convert zeroes to NA instead of locating randomly at the end of the ranking.}

\item{normAUC}{Whether to normalize the maximum possible AUC to 1 (Default: TRUE).}

\item{aucMaxRank}{Threshold to calculate the AUC (see 'details' section)}

\item{BPPARAM}{Set to use multiple cores. Only used if 'splitByBlocks=TRUE'}

\item{...}{Other arguments}

\item{assayName}{Name of the assay containing the expression matrix (e.g. in \link[SingleCellExperiment]{SingleCellExperiment} objects)}
}
\value{
Matrix with the AUC values (gene-sets as rows, cells as columns).
}
\description{
Runs AUCell (calculates the ranking + score genesets)
}
\details{
In a simplified way, the AUC value represents the fraction of genes,
 within the top X genes in the ranking, that are included in the signature.
The parameter 'aucMaxRank' allows to modify the number of genes
(maximum ranking) that is used to perform this computation.
By default, it is set to 5\% of the total number of genes in the rankings.
Common values may range from 1 to 20\%.
}
\examples{
# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
exprMatrix <- as(exprMatrix, "dgCMatrix")

# In this example we use two gene sets: 10 and 5 random genes
# (see other formatting examples at the end)
fewGenes <- sample(rownames(exprMatrix), 10)
otherGenes <- sample(rownames(exprMatrix), 5)

geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
geneSets

# Calculate AUCell score for the genes in the sets
# To be able to run this fake example (which contain only 20 genes),
# we use aucMaxRank=5 (top 25\% of the genes in the ranking)
cells_AUC <- AUCell_run(exprMatrix, geneSets, aucMaxRank=5)


## To run in paralell:
# cells_AUC <- AUCell_run(exprMatrix, geneSets, aucMaxRank=5, 
#                   BPPARAM=BiocParallel::MulticoreParam(5))



# Format of the output:
cells_AUC

# To subset & access the AUC slot (as matrix):
cells_AUC[1:2,]
cells_AUC[,3:4]
getAUC(cells_AUC)[,1:5]


# These methods are also available:
dim(cells_AUC)
nrow(cells_AUC)
ncol(cells_AUC)
colnames(cells_AUC)[1:4]
rownames(cells_AUC)

#########################################################
# Alternatives for the input of gene sets:

# a) Character vector (i.e. only one gene-set)
# It will take the default name 'geneSet'
fewGenes
test <- AUCell_run(exprMatrix, fewGenes, aucMaxRank=5)

# b) List
geneSets <- list(geneSet1=fewGenes,
                 geneSet2=otherGenes)
geneSets
test <- AUCell_run(exprMatrix, fewGenes, aucMaxRank=5)

# c) GeneSet object (from GSEABase)
library(GSEABase)
geneSetOne <- GeneSet(fewGenes, setName="geneSetOne")
geneSetOne
test <- AUCell_run(exprMatrix, fewGenes, aucMaxRank=5)


# d) GeneSetCollection object (from GSEABase)
geneSetTwo <- GeneSet(otherGenes, setName="geneSetTwo")
geneSets <- GeneSetCollection(geneSetOne, geneSetTwo)
geneSets
test <- AUCell_run(exprMatrix, fewGenes, aucMaxRank=5)

}
\seealso{
Includes \code{\link{AUCell_buildRankings}} and \code{\link{AUCell_calcAUC}}.
Next step in the workflow: \code{\link{AUCell_exploreThresholds}}.

See the package vignette for examples and more details:
\code{vignette("AUCell")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_AUCell_assignCells.R
\name{AUCell_assignCells}
\alias{AUCell_assignCells}
\title{AUCell_assignCells}
\usage{
AUCell_assignCells(cellsAUC, thresholds, nCores = 1)
}
\arguments{
\item{cellsAUC}{AUC object returned by \code{\link{AUCell_calcAUC}}.}

\item{thresholds}{Thresholds selected for each geneset (named vector).}

\item{nCores}{Number of cores to use for computation.}
}
\value{
List with the following elements for each gene-set:
\itemize{
\item 'aucThr' threshold value, in the same format as AUCell_exploreThresholds()
\item 'assignment' List of cells that pass the selected AUC threshold
}
}
\description{
Assigns whether the gene sets are considered "active" on each cell
based on the given thresholds
}
\examples{
# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
dim(exprMatrix)
##################################################

######### Previous steps in the workflow #########
# Step 1.
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=FALSE)

# Step 2.
# (Gene sets: random genes)
geneSets <- list(geneSet1=sample(rownames(exprMatrix), 10),
                 geneSet2=sample(rownames(exprMatrix), 5))
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)
##################################################

############## Step 3: Assign cells ##############

# 1. Plot histograms and obtain some pre-computed thresholds
# (this example is only meant to show the interface/arguments of the function,
# see the vignette for meaningful examples)
set.seed(123)
par(mfrow=c(1,2)) # Plot is divided into one row and two columns
thresholds <- AUCell_exploreThresholds(cells_AUC, plotHist=TRUE)
thresholds$geneSet1$aucThr

# 2. Obtain cells over a given threshold:
names(which(getAUC(cells_AUC)["geneSet1",] > 0.19))

# Alternative 1: assign cells according to the 'automatic' threshold
cells_assignment <- AUCell_exploreThresholds(cells_AUC,
                                             plotHist=FALSE, assignCells=TRUE)
# Cells assigned:
getAssignments(cells_assignment)
# Threshold applied:
getThresholdSelected(cells_assignment)

# Alternative 2: choose a threshold manually and assign cells
newThresholds = getThresholdSelected(cells_assignment)
newThresholds['geneSet1'] = 0.8
newAssignments = AUCell_assignCells(cells_AUC, newThresholds)
getAssignments(newAssignments)



}
\seealso{
Previous step in the workflow: \code{\link{AUCell_calcAUC}} 
and optionally \code{\link{AUCell_exploreThresholds}} 

See the package vignette for examples and more details:
\code{vignette("AUCell")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_AUCell_plotHist.R
\name{AUCell_plotHist}
\alias{AUCell_plotHist}
\title{Plot AUC histogram}
\usage{
AUCell_plotHist(
  cellsAUC,
  aucThr = max(cellsAUC),
  nBreaks = 100,
  onColor = "dodgerblue4",
  offColor = "slategray2",
  ...
)
}
\arguments{
\item{cellsAUC}{Subset of the object returned by \code{\link{AUCell_calcAUC}}
(i.e. including only the gene-sets to plot)}

\item{aucThr}{AUC value planned to use as threshold
(to make sure the X axis includes it), if any.
Otherwise, the X axis extends to cover only the AUC values plotted.}

\item{nBreaks}{Number of 'bars' to plot (breaks argument for hist function).}

\item{onColor}{Color for the bars that pass the AUC threshold}

\item{offColor}{Color for the bars that do not pass the AUC threshold}

\item{...}{Other arguments to pass to \code{\link{hist}} function.}
}
\value{
List of histogram objects (invisible).
}
\description{
Plots the distribution of AUC across the cells
(for each gene-set) as an histogram.
}
\examples{
# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
dim(exprMatrix)
##################################################

############# Begining of the workflow ###########
# Step 1.
cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=FALSE)

# Step 2.
# (Gene set: 10 random genes)
genes <- sample(rownames(exprMatrix), 10)
geneSets <- list(geneSet1=genes)
# (aucMaxRank=5 to run with this fake example, it will return 'high' AUC values)
cells_AUC <- AUCell_calcAUC(geneSets, cells_rankings, aucMaxRank=5)
##################################################

# Plot histogram:
AUCell_plotHist(cells_AUC["geneSet1",], nBreaks=10)

}
\seealso{
See the package vignette for examples and more details:
\code{vignette("AUCell")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aux_plotEmb_rgb.R
\name{plotEmb_rgb}
\alias{plotEmb_rgb}
\title{plotEmb_rgb}
\usage{
plotEmb_rgb(
  aucMat,
  embedding,
  geneSetsByCol,
  aucType = "AUC",
  aucMaxContrast = 0.8,
  offColor = "#c0c0c030",
  showPlot = TRUE,
  showLegend = TRUE,
  ...
)
}
\arguments{
\item{aucMat}{AUC matrix (continuous or binary)}

\item{embedding}{AUC matrix (continuous or binary)}

\item{geneSetsByCol}{Gene sets to plot}

\item{aucType}{"AUC" or "Binary"}

\item{aucMaxContrast}{To increase the AUC contrast decrease the value.}

\item{offColor}{Color por the cells completelly off. To deactivate (color as black), set to NULL.}

\item{showPlot}{Whether to plot the coloured embeddings.}

\item{showLegend}{Whether to plot add a legend to the plot.}

\item{...}{Other arguments to pass to the \code{plot} function.}
}
\value{
The cell colors (invisible)
}
\description{
Colors the embeddings (t-SNE/Umap) based on the activity of 3 (groups of) geneSets
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/01_buildRankings.R
\name{AUCell_buildRankings}
\alias{AUCell_buildRankings}
\alias{AUCell_buildRankings,dgCMatrix-method}
\alias{AUCell_buildRankings,matrix-method}
\alias{AUCell_buildRankings,ExpressionSet-method}
\alias{AUCell_buildRankings,SummarizedExperiment-method}
\title{Build gene expression rankings for each cell}
\usage{
AUCell_buildRankings(
  exprMat,
  featureType = "genes",
  plotStats = TRUE,
  splitByBlocks = FALSE,
  BPPARAM = NULL,
  keepZeroesAsNA = FALSE,
  verbose = TRUE,
  nCores = NULL,
  mctype = NULL,
  ...
)

\S4method{AUCell_buildRankings}{dgCMatrix}(
  exprMat,
  featureType = "genes",
  plotStats = TRUE,
  splitByBlocks = TRUE,
  BPPARAM = NULL,
  keepZeroesAsNA = FALSE,
  verbose = TRUE,
  nCores = NULL,
  mctype = NULL
)

\S4method{AUCell_buildRankings}{matrix}(
  exprMat,
  featureType = "genes",
  plotStats = TRUE,
  splitByBlocks = FALSE,
  BPPARAM = NULL,
  keepZeroesAsNA = FALSE,
  verbose = TRUE,
  nCores = NULL,
  mctype = NULL
)

\S4method{AUCell_buildRankings}{ExpressionSet}(
  exprMat,
  featureType = "genes",
  plotStats = TRUE,
  splitByBlocks = FALSE,
  BPPARAM = NULL,
  keepZeroesAsNA = FALSE,
  verbose = TRUE,
  nCores = NULL,
  mctype = NULL
)

\S4method{AUCell_buildRankings}{SummarizedExperiment}(
  exprMat,
  featureType = "genes",
  plotStats = TRUE,
  splitByBlocks = FALSE,
  BPPARAM = NULL,
  keepZeroesAsNA = FALSE,
  verbose = TRUE,
  assayName = NULL,
  nCores = NULL,
  mctype = NULL
)
}
\arguments{
\item{exprMat}{Expression matrix (genes as rows, cells as columns)
The expression matrix can also be provided as one of the R/Bioconductor classes:
\itemize{
\item \link[Matrix]{dgCMatrix-class}:
Sparse matrix 
\item \link{RangedSummarizedExperiment} and derived classes (e.g. \link[SingleCellExperiment]{SingleCellExperiment} ):
The matrix will be obtained through assay(exprMatrix),
-which will extract the first assay (usually the counts)-
or the assay name given in 'assayName'
\item \code{ExpressionSet}:
The matrix will be obtained through exprs(exprMatrix)
}}

\item{featureType}{Name for the rows (e.g. "genes"). Only for naming the rankings, not used internally.}

\item{plotStats}{Should the function plot the expression boxplots/histograms?
(TRUE / FALSE). These plots can also be produced
with the function \code{\link{plotGeneCount}}.}

\item{splitByBlocks}{Whether to split the matrix by blocks in the ranking calculation. 
Allows using multiple cores.
FALSE by default. If using sparse matrices it is automatically set to TRUE.}

\item{BPPARAM}{Set to use multiple cores. Only used if 'splitByBlocks=TRUE'}

\item{keepZeroesAsNA}{Convert zeroes to NA instead of locating randomly at the end of the ranking.}

\item{verbose}{Should the function show progress messages? (TRUE / FALSE)}

\item{nCores}{Deprecated}

\item{mctype}{Deprecated}

\item{...}{Other arguments}

\item{assayName}{Name of the assay containing the expression matrix (e.g. in \link[SingleCellExperiment]{SingleCellExperiment} objects)}
}
\value{
Ranking of the feature within the cell (features as rows, cells as columns)
}
\description{
Builds the "rankings" for each cell:
expression-based ranking for all the genes in each cell.

The genes with same expression value are shuffled.
Therefore, genes with expression '0' are randomly sorted at the
end of the ranking.

These "rankings" can be seen as a new representation of the original dataset.
Once they are calculated, they can be saved for future analyses.
}
\details{
It is important to check that most cells have at least the number of
expressed/detected genes that are going to be used to calculate the AUC
(`aucMaxRank` in `calcAUC()`).
The histogram provided by `AUCell_buildRankings()`
allows to quickly check this distribution.
`plotGeneCount(exprMatrix)` allows to obtain only the plot before
building the rankings.
}
\examples{
# This example is run using a fake expression matrix.
# Therefore, the output will be meaningless.

############# Fake expression matrix #############
set.seed(123)
exprMatrix <- matrix(data=sample(c(rep(0, 5000), sample(1:3, 5000, replace=TRUE))),
                     nrow=20, 
                     dimnames=list(paste("Gene", 1:20, sep=""), 
                                   paste("Cell", 1:500, sep="")))
##################################################

cells_rankings <- AUCell_buildRankings(exprMatrix, plotStats=TRUE)
cells_rankings
}
\seealso{
Next step in the workflow: \code{\link{AUCell_calcAUC}}.

See the package vignette for examples and more details:
\code{vignette("AUCell")}
}
